Import & Export

SpreadJS supports the opening and saving to several popular file formats including Excel .xlsx/.xlsm, .csv, .ssjson (older SpreadJS format) and the new faster .sjs SpreadJS file formats. The new .sjs format significantly improves the load time and memory usage when working with very large Excel files while greatly reducing the file size when resaved as compared to previous SpreadJS versions.

Learn more about opening password protected Excel files.

Description
app.js
index.html
styles.css
Copy to CodeMine

In order to use the SpreadJS File Format feature, you need to add the related js file link into the document's head section below the Spread link. For example:

<head>
   ...
   <script src='.../spreadjs/gc.spread.sheets.all.x.x.x.min.js' type='text/javascript'></script>
   <script src='.../spreadjs/plugins/gc.spread.sheets.io.x.x.x.min.js' type='text/javascript'></script>
</head>

SpreadJS supports opening and saving sjs file formats. It also supports importing and exporting xlsx, ssjson, and csv file formats.

For example:

// open the sjs file to spread.
spread.open(file, function () {
   // success callback to do something 
}, function (e) {
   console.log(e); // error callback
});

// save spread to sjs file.
spread.save(function (blob) {
   // save blob to a file
   saveAs(blob, fileName);
}, function (e) {
   console.log(e);
});

// import the xlsx, ssjson, csv file to spread.
spread.import(file, function () {
   // success callback to do something
}, function (e) {
   console.log(e); // error callback
}, {
   fileType: GC.Spread.Sheets.FileType.excel
});

// export spread to xlsx, ssjson, csv file.
spread.export(function (blob) {
   // save blob to a file
   saveAs(blob, fileName);
}, function (e) {
   console.log(e);
}, {
   fileType: GC.Spread.Sheets.FileType.excel
});

class GC.Spread.Sheets.Workbook

export class Workbook {
  ///* function GC.Spread.Sheets.@Workbook.save(successCallBack?: Function, errorCallBack?: Function, saveOptions?: GC.Spread.Sheets.SaveOptions): void
  /**
  * Saves the spreadJS state to a sjs file.
  * @param {function} successCallBack - The success callback when save spreadJS state complete, accept Blob as argument.
  * @param {function} errorCallBack - The error callback when save spreadJS state got error.
  * @param {GC.Spread.Sheets.SaveOptions} saveOptions - The save options.
  * @example
  * spread.save(function (blob) {
  *    // save blob to a file
  *    saveAs(blob, fileName);
  * }, function (e) {
  *    console.log(e);
  * }, { includeUnusedNames: false });
  */
  Workbook.prototype.save = function (this: Workbook, successCallBack?: (content: Blob) => {}, errorCallBack?, saveOptions?: SaveOptions): void;

  ///* function GC.Spread.Sheets.@Workbook.open(file: File, successCallback?: Function, errorCallback?: Function, openOptions?: GC.Spread.Sheets.OpenOptions)
  /**
  * Loads the object state from the sjs zipped file.
  * @param {Blob} file - The zipped spreadsheet data file.
  * @param {function} successCallBack - The success callback when import file complete, accept json as argument.
  * @param {function} errorCallBack - The error callback when import file got error.
  * @param {GC.Spread.Sheets.OpenOptions} [openOptions] - The deserialization options.
  * @example
  * //This example uses the open method.
  * //Get file blob.
  * var file = document.getElementById("importFileName").files[0];
  * // import
  * spread.open(file, function () {
  *    // success callback to do something
  * }, function (e) {
  *  console.log(e); // error callback
  * });
  */
  Workbook.prototype.open = function (file: Blob, successCallback?, errorCallback?, openOptions?: OpenOptions): void;

  ///* function GC.Spread.Sheets.@Workbook.export(successCallBack?: Function, errorCallBack?: Function, exportOptions?: GC.Spread.Sheets.ExportOptions): void
  /**
  * Exports the object state to excel or ssjson file or csv file.
  * @param {function} [successCallBack] The success callback when export object state complete, accept Blob as argument.
  * @param {function} [errorCallBack] The error callback when export object state got error.
  * @param {GC.Spread.Sheets.ExportOptions} [exportOptions] - The export options.
  * @example
  * spread.export(function (blob) {
  *    // save blob to a file
  *    saveAs(blob, fileName);
  * }, function (e) {
  *    console.log(e);
  * }, {
  *    fileType: GC.Spread.Sheets.FileType.excel,
  *    includeBindingSource: true
  * });
  */
  Workbook.prototype.export = function (successCallBack?: (content: Blob) => {}, errorCallBack?, exportOptions?: ExportOptions);

  ///* function GC.Spread.Sheets.@Workbook.import(file: File, successCallback?: Function, errorCallback?: Function, importOptions?: GC.Spread.Sheets.ImportOptions)
  /**
  * Imports the object state from the excel or ssJson or csv file.
  * @param {File} file - The ssJson or csv or Excel file for import.
  * @param {function} [successCallBack] - The success callback when import file complete, accept json as argument. ???
  * @param {function} [errorCallBack] - The error callback when import file got error.
  * @param {GC.Spread.Sheets.ImportOptions} [importOptions] - The import options.
  * @example
  * //This example uses the import method.
  * //Get file blob.
  * var file = document.getElementById("importFileName").files[0];
  * // import
  * spread.import(file, function () {
  *    // success callback to do something
  * }, function (e) {
  *    console.log(e); // error callback
  * }, {
  *    fileType: GC.Spread.Sheets.FileType.excel
  * });
  */
  Workbook.prototype.import = function (file: File, successCallback?, errorCallback?, importOptions?: ImportOptions);
}

GC.Spread.Sheets.SaveOptions

///* typedef GC.Spread.Sheets.SaveOptions
/**
 * @typedef GC.Spread.Sheets.SaveOptions
 * @property {boolean} [includeBindingSource] - Whether to include the binding source when do save, default false.
 * @property {boolean} [includeStyles] - Whether to include the style when do save, default true.
 * @property {boolean} [includeFormulas] - Whether to include the formula when do save, default true.
 * @property {boolean} [saveAsView] - Whether to ignore the format string when do save, default false.
 * @property {boolean} [includeAutoMergedCells] - Whether to include the automatically merged cells when do save, default false.
 * @property {boolean} [includeCalcModelCache] - Whether to include the extra data of calculation. Can be faster when open the file with those data, default false.
 * @property {boolean} [includeUnusedNames] - Whether to include the unused custom name when do save, default true.
 * @property {boolean} [includeEmptyRegionCells] - Whether to include any empty cells(cells with no data or only style) outside the used data range, default true.
 * @property {boolean} [saveR1C1Formula] - Whether to save the r1c1 formula in the file, only works in sjs file type, default false.
 */

GC.Spread.Sheets.OpenOptions

///* typedef GC.Spread.Sheets.OpenOptions
/**
 * @typedef GC.Spread.Sheets.OpenOptions
 * @property {boolean} [includeStyles] - Whether to include the style when loading, default true.
 * @property {boolean} [includeFormulas] - Whether to include the formula when loading, default true.
 * @property {boolean} [fullRecalc] - Whether to calculate after loading the json data, false by default.
 * @property {boolean} [dynamicReferences] - Whether to calculate functions with dynamic reference, default true.
 * @property {boolean} [calcOnDemand] - Whether to calculate formulas only when they are demanded, default false.
 * @property {boolean} [incrementalCalculation] - Whether to incremental calculate formulas without blocking UI, default false.
 * @property {boolean} [includeUnusedStyles] - Whether to include the name style when converting excel xml to the json, default true.
 * @property {GC.Spread.Sheets.OpenMode} [openMode] - The open mode of normal, lazy and incremental. By default is normal.
 * @property {GC.Spread.Sheets.ProgressFunctionType} [progress] - The progress callback function for each open mode.
 */

 ///* enum GC.Spread.Sheets.OpenMode
/**
 * The open mode for open sjs function.
 * @enum {number}
 */
 enum OpenMode {
    /**
    * normal open mode, without lazy and incremental. When opening file, UI and UI event could be refreshed and responsive at specific time points.
    */
    normal = 0,
    /**
    * lazy open mode. When opening file, only the active sheet will be loaded directly. Other sheets will be loaded only when they are be used.
    */
    lazy = 1,
    /**
    * incremental open mode. When opening file, UI and UI event could be refreshed and responsive directly.
    */
    incremental = 2
}

///* typedef GC.Spread.Sheets.ProgressFunctionType
/**
 * @typedef GC.Spread.Sheets.ProgressFunctionType
 * @param {object} progressArgs - the progress arguments.
 * @param {string} [progressArgs.sheetName] - the current loading sheet's name.
 * @param {string} progressArgs.step - the current loading step.
 * @param {number} progressArgs.progress - the current loading progress, from 0 - 1.
 * @returns {void}
 * @description The callback when of the incremental loading progress.
 */
export type ProgressFunctionType = (progressArgs: ProgressArgs) => void;

GC.Spread.Sheets.ImportOptions

///* typedef GC.Spread.Sheets.ImportOptions
/**
 * @typedef {GC.Spread.Sheets.FileOptions & (GC.Spread.Sheets.ImportCsvOptions | GC.Spread.Sheets.ImportSSJsonOptions | GC.Spread.Sheets.ImportXlsxOptions)} GC.Spread.Sheets.ImportOptions - The options for import function. */
/**
 GC.Spread.Sheets.FileOptions & (GC.Spread.Sheets.ImportCsvOptions | GC.Spread.Sheets.ImportSSJsonOptions | GC.Spread.Sheets.ImportXlsxOptions)
*/

///* typedef GC.Spread.Sheets.FileOptions
/**
 * @typedef GC.Spread.Sheets.FileOptions - The file options for export.
 * @property {GC.Spread.Sheets.FileType} fileType - The file type.
 */
/**
{
    fileType: GC.Spread.Sheets.FileType
}
*/

GC.Spread.Sheets.ExportOptions

///* typedef GC.Spread.Sheets.ExportOptions
/**
 * @typedef {GC.Spread.Sheets.FileOptions & (GC.Spread.Sheets.ExportCsvOptions | GC.Spread.Sheets.ExportSSJsonOptions | GC.Spread.Sheets.ExportXlsxOptions)} GC.Spread.Sheets.ExportOptions - The options for export function.
 */
/**
 GC.Spread.Sheets.FileOptions & (GC.Spread.Sheets.ExportCsvOptions | GC.Spread.Sheets.ExportSSJsonOptions | GC.Spread.Sheets.ExportXlsxOptions)
*/

///* typedef GC.Spread.Sheets.FileOptions
/**
 * @typedef GC.Spread.Sheets.FileOptions - The file options for export.
 * @property {GC.Spread.Sheets.FileType} fileType - The file type.
 */
/**
{
    fileType: GC.Spread.Sheets.FileType
}
*/

GC.Spread.Sheets.ImportXlsxOptions

///* typedef GC.Spread.Sheets.ImportXlsxOptions
/**
 * @typedef GC.Spread.Sheets.ImportXlsxOptions
 * @property {boolean} [includeStyles] - Whether to include the style when loading, default true.
 * @property {boolean} [includeFormulas] - Whether to include the formula when loading, default true.
 * @property {boolean} [frozenColumnsAsRowHeaders] - Whether to treat the frozen columns as row headers when loading, default false.
 * @property {boolean} [frozenRowsAsColumnHeaders] - Whether to treat the frozen rows as column headers when loading, default false.
 * @property {boolean} [fullRecalc] - Whether to calculate after loading the json data, false by default.
 * @property {boolean} [dynamicReferences] - Whether to calculate functions with dynamic reference, default true.
 * @property {boolean} [calcOnDemand] - Whether to calculate formulas only when they are demanded, default false.
 * @property {boolean} [incrementalCalculation] - Whether to incremental calculate formulas without blocking UI, default false.
 * @property {boolean} [includeUnusedStyles] - Whether to include the name style when converting excel xml to the json, default true.
 * @property {boolean} [convertSheetTableToDataTable] - Whether to convert the sheet tables to data manager tables, default false.
 * @property {GC.Spread.Sheets.OpenMode} [openMode] - The open mode of normal, lazy and incremental. By default is lazy.
 * @property {GC.Spread.Sheets.ProgressFunctionType} [progress] - The progress callback function for each open mode.
 */
/**
{
    includeStyles?: boolean;
    frozenColumnsAsRowHeaders?: boolean;
    frozenRowsAsColumnHeaders?: boolean;
    includeFormulas?: boolean;
    fullRecalc?: boolean;
    dynamicReferences?: boolean;
    calcOnDemand?: boolean;
    includeUnusedStyles?: boolean;
    convertSheetTableToDataTable?: boolean;
    incrementalCalculation?: boolean;
    openMode?: GC.Spread.Sheets.OpenMode;
    progress?: GC.Spread.Sheets.ProgressFunctionType
}
*/

GC.Spread.Sheets.ExportXlsxOptions

///* typedef GC.Spread.Sheets.ExportXlsxOptions
/**
 * @typedef GC.Spread.Sheets.ExportXlsxOptions
 * @property {boolean} [includeBindingSource] - Whether to include the binding source when do save, default false.
 * @property {boolean} [includeStyles] - Whether to include the style when do save, default true.
 * @property {boolean} [includeFormulas] - Whether to include the formula when do save, default true.
 * @property {boolean} [saveAsView] - Whether to ignore the format string when do save, default false.
 * @property {boolean} [rowHeadersAsFrozenColumns] - Whether to treat the row headers as frozen columns when do save, default false.
 * @property {boolean} [columnHeadersAsFrozenRows] - Whether to treat the column headers as frozen rows when do save, default false.
 * @property {boolean} [includeAutoMergedCells] - Whether to include the automatically merged cells when do save, default false.
 * @property {boolean} [includeUnusedNames] - Whether to include the unused custom name when do save, default true.
 * @property {boolean} [includeEmptyRegionCells] - Whether to include any empty cells(cells with no data or only style) outside the used data range, default true.
 */
/**
{
    includeBindingSource?: boolean;
    includeStyles?: boolean;
    includeFormulas?: boolean;
    saveAsView?: boolean;
    rowHeadersAsFrozenColumns?: boolean;
    columnHeadersAsFrozenRows?: boolean;
    includeUnusedNames?: boolean;
    includeEmptyRegionCells?: boolean;
    includeAutoMergedCells?: boolean;
}
*/

GC.Spread.Sheets.ImportCsvOptions

///* typedef GC.Spread.Sheets.ImportCsvOptions
/**
 * @typedef GC.Spread.Sheets.ImportCsvOptions
 * @property {string} [encoding] - The csv encoding type, the default encoding type is 'UTF-8'.
 * @property {string} [rowDelimiter] - The row delimiter that is appended to the end of the row, the default row delimiter is '\r\n'.
 * @property {string} [columnDelimiter] - The column delimiter that is appended to the end of the column, the default column delimiter is ','.
 */
/**
{
    rowDelimiter?: string;
    columnDelimiter?: string;
    encoding?: string;
}
*/

.Spread.Sheets.ExportCsvOptions

///* typedef GC.Spread.Sheets.ExportCsvOptions
/**
 * @typedef GC.Spread.Sheets.ExportCsvOptions
 * @property {string} [encoding] - The csv encoding type, the default encoding type is 'UTF-8'.
 * @property {string} [rowDelimiter] - The row delimiter that is appended to the end of the row, the default row delimiter is '\r\n'.
 * @property {string} [columnDelimiter] - The column delimiter that is appended to the end of the column, the default column delimiter is ','.
 * @property {object} [range] - The range info.
 * @param {number} [range.sheetIndex] - The sheet index, the default sheet index is current active sheet index.
 * @param {number} [range.row] - The start row, the default row index is 0.
 * @param {number} [range.column] - The start column, the default column index is 0.
 * @param {number} [range.rowCount] - The row count, the default row count is current active sheet row count.
 * @param {number} [range.columnCount] - The column count, the default column count is current active sheet column count.

 */
/**
{
    encoding?: string;
    rowDelimiter?: string;
    columnDelimiter?: string;
    range?: {
        sheetIndex: number;
        row: number;
        column: number;
        rowCount: number;
        columnCount: number;
    }
}
*/

GC.Spread.Sheets.ImportSSJsonOptions

///* typedef GC.Spread.Sheets.ImportSSJsonOptions
/**
 * @typedef GC.Spread.Sheets.ImportSSJsonOptions
 * @property {boolean} [includeStyles] - Whether to include the style when converting json to the workbook, default true.
 * @property {boolean} [includeFormulas] - Whether to include the formula when converting json to the workbook, default true.
 * @property {boolean} [frozenColumnsAsRowHeaders] - Whether to treat the frozen columns as row headers when converting json to the workbook, default false.
 * @property {boolean} [frozenRowsAsColumnHeaders] - Whether to treat the frozen rows as column headers when converting json to the workbook, default false.
 * @property {boolean} [fullRecalc] - Whether to do full recalculation after loading the json data, default true.
 * @property {boolean | object} [incrementalLoad] - Whether to use the incremental loading or the callbacks of incremental loading when converting json to the workbook, default false.
 * @param {function} [incrementalLoad.loading] - The callback when of the incremental loading progress.
 * @param {function} [incrementalLoad.loaded] - The callback when of the incremental loading finished.
 */
/**
{
    includeStyles?: boolean;
    incrementalLoad?: any;
    frozenColumnsAsRowHeaders?: boolean;
    frozenRowsAsColumnHeaders?: boolean;
    includeFormulas?: boolean;
    fullRecalc?: boolean;
}
*/

GC.Spread.Sheets.ExportSSJsonOptions

///* typedef GC.Spread.Sheets.ExportSSJsonOptions
/**
 * @typedef GC.Spread.Sheets.ExportSSJsonOptions
 * @property {boolean} [includeBindingSource] - Whether to include the binding source when converting the workbook to json, default false.
 * @property {boolean} [includeStyles] - Whether to include the style when converting the workbook to json, default true.
 * @property {boolean} [includeFormulas] - Whether to include the formula when converting the workbook to json, default true.
 * @property {boolean} [saveAsView] - Whether to ignore the format string when converting the workbook to json, default false.
 * @property {boolean} [rowHeadersAsFrozenColumns] - Whether to treat the row headers as frozen columns when converting the workbook to json, default false.
 * @property {boolean} [columnHeadersAsFrozenRows] - Whether to treat the column headers as frozen rows when converting the workbook to json, default false.
 * @property {boolean} [includeAutoMergedCells] - Whether to include the automatically merged cells when converting the workbook to json, default false.
 */
/**
{
    includeBindingSource?: boolean;
    includeStyles?: boolean;
    includeFormulas?: boolean;
    saveAsView?: boolean;
    rowHeadersAsFrozenColumns?: boolean;
    columnHeadersAsFrozenRows?: boolean;
    includeAutoMergedCells?: boolean;
}
*/
In order to use the SpreadJS File Format feature, you need to add the related js file link into the document's head section below the Spread link. For example: SpreadJS supports opening and saving sjs file formats. It also supports importing and exporting xlsx, ssjson, and csv file formats. For example: class GC.Spread.Sheets.Workbook GC.Spread.Sheets.SaveOptions GC.Spread.Sheets.OpenOptions GC.Spread.Sheets.ImportOptions GC.Spread.Sheets.ExportOptions GC.Spread.Sheets.ImportXlsxOptions GC.Spread.Sheets.ExportXlsxOptions GC.Spread.Sheets.ImportCsvOptions .Spread.Sheets.ExportCsvOptions GC.Spread.Sheets.ImportSSJsonOptions GC.Spread.Sheets.ExportSSJsonOptions
var openOptions = [ { propName: "openMode", type: "select", displayText: "OpenMode", options: [{name: 'normal', value: 0}, {name: 'lazy', value: 1}, {name: 'incremental', value: 2}], default: 0 }, { propName: "includeStyles", type: "boolean", default: true }, { propName: "includeFormulas", type: "boolean", default: true }, { propName: "fullRecalc", type: "boolean", default: false }, { propName: "dynamicReferences", type: "boolean", default: true }, { propName: "calcOnDemand", type: "boolean", default: false }, { propName: "includeUnusedStyles", type: "boolean", default: true }, ]; var importXlsxOptions = [ { propName: "openMode", type: "select", displayText: "OpenMode", options: [{name: 'normal', value: 0}, {name: 'lazy', value: 1}, {name: 'incremental', value: 2}], default: 0 }, { propName: "includeStyles", type: "boolean", default: true }, { propName: "includeFormulas", type: "boolean", default: true }, { propName: "frozenColumnsAsRowHeaders", type: "boolean", default: false }, { propName: "frozenRowsAsColumnHeaders", type: "boolean", default: false }, { propName: "fullRecalc", type: "boolean", default: false }, { propName: "dynamicReferences", type: "boolean", default: true }, { propName: "calcOnDemand", type: "boolean", default: false }, { propName: "includeUnusedStyles", type: "boolean", default: true }, { propName: "convertSheetTableToDataTable", type: "boolean", default: false }, ]; var importSSJsonOptions = [ { propName: "includeStyles", type: "boolean", default: true }, { propName: "includeFormulas", type: "boolean", default: true }, { propName: "frozenColumnsAsRowHeaders", type: "boolean", default: false }, { propName: "frozenRowsAsColumnHeaders", type: "boolean", default: false }, { propName: "fullRecalc", type: "boolean", default: false }, { propName: "incrementalLoading", type: "boolean", default: false } ]; var importCsvOptions = [ { propName: "encoding", type: "string", default: "UTF-8" }, { propName: "rowDelimiter", type: "string", default: "\r\n" }, { propName: "columnDelimiter", type: "string", default: "," } ]; var saveOptions = [ { propName: "includeBindingSource", type: "boolean", default: false }, { propName: "includeStyles", type: "boolean", default: true }, { propName: "includeFormulas", type: "boolean", default: true }, { propName: "saveAsView", type: "boolean", default: false }, { propName: "includeAutoMergedCells", type: "boolean", default: false }, { propName: "includeCalcModelCache", type: "boolean", default: false }, { propName: "saveR1C1Formula", type: "boolean", default: false }, { propName: "includeUnusedNames", type: "boolean", default: true }, { propName: "includeEmptyRegionCells", type: "boolean", default: true }, ]; var exportXlsxOptions = [ { propName: "includeBindingSource", type: "boolean", default: false }, { propName: "includeStyles", type: "boolean", default: true }, { propName: "includeFormulas", type: "boolean", default: true }, { propName: "saveAsView", type: "boolean", default: false }, { propName: "rowHeadersAsFrozenColumns", type: "boolean", default: false }, { propName: "columnHeadersAsFrozenRows", type: "boolean", default: false }, { propName: "includeAutoMergedCells", type: "boolean", default: false }, { propName: "includeUnusedNames", type: "boolean", default: true }, { propName: "includeEmptyRegionCells", type: "boolean", default: true }, ]; var exportSSJsonOptions = [ { propName: "includeBindingSource", type: "boolean", default: false }, { propName: "includeStyles", type: "boolean", default: true }, { propName: "includeFormulas", type: "boolean", default: true }, { propName: "saveAsView", type: "boolean", default: false }, { propName: "rowHeadersAsFrozenColumns", type: "boolean", default: false }, { propName: "columnHeadersAsFrozenRows", type: "boolean", default: false }, { propName: "includeAutoMergedCells", type: "boolean", default: false }, ]; var exportCsvOptions = [ { propName: "encoding", type: "string", default: "UTF-8" }, { propName: "rowDelimiter", type: "string", default: "\r\n" }, { propName: "columnDelimiter", type: "string", default: "," }, { propName: "sheetIndex", type: "number", default: 0 }, { propName: "row", type: "number", default: 0 }, { propName: "column", type: "number", default: 0 }, { propName: "rowCount", type: "number", default: 200 }, { propName: "columnCount", type: "number", default: 20 }, ]; var FileType = { SJS: 'sjs', Excel: 'xlsx', SSJson: 'ssjson', Csv: 'csv', } var openOptionsDict = {}; openOptionsDict[FileType.SJS] = openOptions; openOptionsDict[FileType.Excel] = importXlsxOptions; openOptionsDict[FileType.SSJson] = importSSJsonOptions; openOptionsDict[FileType.Csv] = importCsvOptions; var saveOptionsDict = {}; saveOptionsDict[FileType.SJS] = saveOptions; saveOptionsDict[FileType.Excel] = exportXlsxOptions; saveOptionsDict[FileType.SSJson] = exportSSJsonOptions; saveOptionsDict[FileType.Csv] = exportCsvOptions; window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss")); var statusBar = new GC.Spread.Sheets.StatusBar.StatusBar(document.getElementById('statusBar')); statusBar.bind(spread); initDefaultOptions(); var selectedFileElement = document.querySelector('#selectedFile'); selectedFileElement.addEventListener("change", function() { var file = selectedFileElement.files[0]; updateOptions('open', getFileType(file)); }); var saveFileType = document.querySelector('#saveFileType'); saveFileType.addEventListener("change", function() { var fileType = saveFileType.value; updateOptions('save', fileType); }); document.getElementById('open').onclick = function () { var file = document.querySelector('#selectedFile').files[0]; if (!file) { return; } var fileType = getFileType(file); var options = getOptions('open'); if (fileType === FileType.SJS) { spread.open(file, function() {}, function() {}, options); } else { spread.import(file, function() {}, function() {}, options); } }; document.getElementById('save').onclick = function () { var fileName = 'export.' + saveFileType.value; var fileType = saveFileType.value; var options = getOptions('save'); if (fileType === FileType.SJS) { spread.save(function(blob) { saveAs(blob, fileName); }, function() {}, options); } else { if (fileType === FileType.Csv) { var { sheetIndex, row, rowCount, column, columnCount } = options; options.range = { sheetIndex: sheetIndex, row: row, rowCount: rowCount, column: column, columnCount: columnCount, }; } options.fileType = mapExportFileType(fileType); spread.export(function(blob) { saveAs(blob, fileName); }, function() {}, options); } }; }; function initOptions (options, fileType, mode) { var container = document.createElement('div'); container.className = fileType; container.style.display = 'none'; options.forEach(function (prop) { var item = document.createElement('div'); item.className = 'item'; var id = getElementId(mode, fileType, prop.propName); var label = document.createElement("label"); label.innerText = prop.displayText || prop.propName; label.for = id; if (prop.type === 'select') { var select = document.createElement('select'); prop.options.forEach(function(p) { var option = document.createElement('option'); option.value = p.value; option.text = p.name; select.appendChild(option); }); select.id = id; select.value = prop.default; item.appendChild(label); item.appendChild(select); } else { var input = document.createElement('input'); input.id = getElementId(mode, fileType, prop.propName); if (prop.type === 'boolean') { input.type ='checkbox'; input.checked = prop.default; item.appendChild(input); item.appendChild(label); } else if (prop.type === 'number') { input.type = 'number'; input.value = prop.default; item.appendChild(label); item.appendChild(input); } else if (prop.type === 'string') { input.type = 'text'; input.value = prop.default; item.appendChild(label); item.appendChild(input); } } container.appendChild(item); }); return container; } function initDefaultOptions () { var container = document.querySelector('.open-options'); var mode = 'open'; container.appendChild(initOptions(openOptions, FileType.SJS, mode)); container.appendChild(initOptions(importXlsxOptions, FileType.Excel, mode)); container.appendChild(initOptions(importSSJsonOptions, FileType.SSJson, mode)); container.appendChild(initOptions(importCsvOptions, FileType.Csv, mode)); container = document.querySelector('.save-options'); mode = 'save'; container.appendChild(initOptions(saveOptions, FileType.SJS, mode)); container.appendChild(initOptions(exportXlsxOptions, FileType.Excel, mode)); container.appendChild(initOptions(exportSSJsonOptions, FileType.SSJson, mode)); container.appendChild(initOptions(exportCsvOptions, FileType.Csv, mode)); updateOptions('save', FileType.SJS); } function updateOptions (mode, fileType) { var container = document.querySelector('.' + mode + '-options'); var oldFileType = container.getAttribute('data-file-type'); if (oldFileType === fileType) { return; } if (oldFileType) { container.querySelector('.' + oldFileType).style.display = 'none'; } if (fileType) { container.querySelector('.' + fileType).style.display = ''; } container.setAttribute('data-file-type', fileType); } function getOptions (mode) { var container = document.querySelector('.' + mode + '-options'); var fileType = container.getAttribute('data-file-type'); if (!fileType) { return; } var options = {}; var props = mode === 'open' ? openOptionsDict[fileType] : saveOptionsDict[fileType]; container = container.querySelector('.' + fileType); props.forEach(function(prop) { var element = container.querySelector('#' + getElementId(mode, fileType, prop.propName)); var value; if (prop.type === 'boolean') { value = element.checked; } else if (prop.type === 'number') { value = +element.value; } else if (prop.type === 'string') { value = element.value; } else if (prop.type === 'select') { value = +element.value; } options[prop.propName] = value; }); return options; } function getElementId (mode, fileType, propName) { return mode + '-' + fileType + '-' + propName; } function getFileType (file) { if (!file) { return; } var fileName = file.name; var extensionName = fileName.substring(fileName.lastIndexOf(".") + 1); if (extensionName === 'sjs') { return FileType.SJS; } else if (extensionName === 'xlsx' || extensionName === 'xlsm') { return FileType.Excel; } else if (extensionName === 'ssjson' || extensionName === 'json') { return FileType.SSJson; } else if (extensionName === 'csv') { return FileType.Csv; } } function mapExportFileType (fileType) { if (fileType === FileType.SSJson) { return GC.Spread.Sheets.FileType.ssjson; } else if (fileType === FileType.Csv) { return GC.Spread.Sheets.FileType.csv; } return GC.Spread.Sheets.FileType.excel; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-print/dist/gc.spread.sheets.print.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-io/dist/gc.spread.sheets.io.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-charts/dist/gc.spread.sheets.charts.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-slicers/dist/gc.spread.sheets.slicers.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-pivot-addon/dist/gc.spread.pivot.pivottables.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-reportsheet-addon/dist/gc.spread.report.reportsheet.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-tablesheet/dist/gc.spread.sheets.tablesheet.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-ganttsheet/dist/gc.spread.sheets.ganttsheet.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/FileSaver.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div class="sample-container"> <div id="ss" class="sample-spreadsheets"></div> <div id="statusBar"></div> </div> <div class="options-container"> <div class="option-row"> <div class="inputContainer"> <input id="selectedFile" type="file" name="files[]" accept=".sjs, .xlsx, .xlsm, .ssjson, .json, .csv" /> <button class="settingButton" id="open">Open</button> <div class="open-options"></div> </div> <div class="inputContainer"> <label for="fileType">FileType:</label> <select id="saveFileType"> <option value="sjs">SJS</option> <option value="xlsx">Excel</option> <option value="ssjson">SSJson</option> <option value="csv">Csv</option> </select> <button class="settingButton" id="save">Save</button> <div class="save-options"></div> </div> </div> </div> </div> </body> </html>
body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-container { width: calc(100% - 280px); height: 100%; float: left; } .sample-spreadsheets { width: 100%; height: calc(100% - 25px); overflow: hidden; } #statusBar { bottom: 0; height: 25px; width: 100%; position: relative; } .options-container { float: right; width: 280px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .sample-options { z-index: 1000; } .inputContainer { width: 100%; height: auto; border: 1px solid #eee; padding: 6px 12px; margin-bottom: 10px; box-sizing: border-box; } .settingButton { color: #fff; background: #82bc00; outline: 0; line-height: 1.5715; position: relative; display: inline-block; font-weight: 400; white-space: nowrap; text-align: center; height: 32px; padding: 4px 15px; font-size: 14px; border-radius: 2px; user-select: none; cursor: pointer; border: 1px solid #82bc00; box-sizing: border-box; margin-bottom: 10px; margin-top: 10px; } .settingButton:hover { color: #fff; border-color: #88b031; background: #88b031; } .options-title { font-weight: bold; margin: 4px 2px; } #selectedFile { width: 180px; } #saveFileType { width: 120px; height: 31px; } .open-options .item { margin: 5px 0px; display: flex; } .save-options .item { margin: 5px 0px; display: flex; } label { margin-left: 3px; } select, input[type="text"], input[type="number"] { display: inline-block; margin-left: auto; width: 120px; font-weight: 400; outline: 0; line-height: 1.5715; border-radius: 2px; border: 1px solid #F4F8EB; box-sizing: border-box; }

Import & Export

SpreadJS supports the opening and saving to several popular file formats including Excel .xlsx/.xlsm/.xltm, .csv, .ssjson (older SpreadJS format) and the new faster .sjs SpreadJS file formats. The new .sjs format significantly improves the load time and memory usage when working with very large Excel files while greatly reducing the file size when resaved as compared to previous SpreadJS versions.

Learn more about opening password protected Excel files.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.component.ts
index.html
app.component.html
styles.css
Copy to CodeMine

In order to use the SpreadJS File Format feature, you need to add the related js file link into the document's head section below the Spread link. For example:

<head>
   ...
   <script src='.../spreadjs/gc.spread.sheets.all.x.x.x.min.js' type='text/javascript'></script>
   <script src='.../spreadjs/plugins/gc.spread.sheets.io.x.x.x.min.js' type='text/javascript'></script>
</head>

SpreadJS supports opening and saving sjs file formats. It also supports importing and exporting xlsx, xlsm, xltm, ssjson, and csv file formats.

For example:

// open the sjs file to spread.
spread.open(file, function () {
   // success callback to do something 
}, function (e) {
   console.log(e); // error callback
});

// save spread to sjs file.
spread.save(function (blob) {
   // save blob to a file
   saveAs(blob, fileName);
}, function (e) {
   console.log(e);
});

// import the xlsx, xlsm, xltm, ssjson, csv file to spread.
spread.import(file, function () {
   // success callback to do something
}, function (e) {
   console.log(e); // error callback
}, {
   fileType: GC.Spread.Sheets.FileType.excel,
   // The importing excel file type ('XLSX' | 'XLSM' | 'XLTM'), default by XLSX.
   excelFileType: 'XLSM'
});

// export spread to xlsx, ssjson, csv file.
spread.export(function (blob) {
   // save blob to a file
   saveAs(blob, fileName);
}, function (e) {
   console.log(e);
}, {
   fileType: GC.Spread.Sheets.FileType.excel,
   // The exporting excel file type ('XLSX' | 'XLSM' | 'XLTM'), default by XLSX.
   excelFileType: 'XLSM'
});

class GC.Spread.Sheets.Workbook

export class Workbook {
  ///* function GC.Spread.Sheets.@Workbook.save(successCallBack?: Function, errorCallBack?: Function, saveOptions?: GC.Spread.Sheets.SaveOptions): void
  /**
  * Saves the spreadJS state to a sjs file.
  * @param {function} successCallBack - The success callback when save spreadJS state complete, accept Blob as argument.
  * @param {function} errorCallBack - The error callback when save spreadJS state got error.
  * @param {GC.Spread.Sheets.SaveOptions} saveOptions - The save options.
  * @example
  * spread.save(function (blob) {
  *    // save blob to a file
  *    saveAs(blob, fileName);
  * }, function (e) {
  *    console.log(e);
  * }, { includeUnusedNames: false });
  */
  Workbook.prototype.save = function (this: Workbook, successCallBack?: (content: Blob) => {}, errorCallBack?, saveOptions?: SaveOptions): void;

  ///* function GC.Spread.Sheets.@Workbook.open(file: File, successCallback?: Function, errorCallback?: Function, openOptions?: GC.Spread.Sheets.OpenOptions)
  /**
  * Loads the object state from the sjs zipped file.
  * @param {Blob} file - The zipped spreadsheet data file.
  * @param {function} successCallBack - The success callback when import file complete, accept json as argument.
  * @param {function} errorCallBack - The error callback when import file got error.
  * @param {GC.Spread.Sheets.OpenOptions} [openOptions] - The deserialization options.
  * @example
  * //This example uses the open method.
  * //Get file blob.
  * var file = document.getElementById("importFileName").files[0];
  * // import
  * spread.open(file, function () {
  *    // success callback to do something
  * }, function (e) {
  *  console.log(e); // error callback
  * });
  */
  Workbook.prototype.open = function (file: Blob, successCallback?, errorCallback?, openOptions?: OpenOptions): void;

  ///* function GC.Spread.Sheets.@Workbook.export(successCallBack?: Function, errorCallBack?: Function, exportOptions?: GC.Spread.Sheets.ExportOptions): void
  /**
  * Exports the object state to excel or ssjson file or csv file.
  * @param {function} [successCallBack] The success callback when export object state complete, accept Blob as argument.
  * @param {function} [errorCallBack] The error callback when export object state got error.
  * @param {GC.Spread.Sheets.ExportOptions} [exportOptions] - The export options.
  * @example
  * spread.export(function (blob) {
  *    // save blob to a file
  *    saveAs(blob, fileName);
  * }, function (e) {
  *    console.log(e);
  * }, {
  *    fileType: GC.Spread.Sheets.FileType.excel,
  *    includeBindingSource: true,
  *    // The exporting excel file type ('XLSX' | 'XLSM' | 'XLTM'), default by XLSX.
  *    excelFileType: 'XLSM'
  * });
  */
  Workbook.prototype.export = function (successCallBack?: (content: Blob) => {}, errorCallBack?, exportOptions?: ExportOptions);

  ///* function GC.Spread.Sheets.@Workbook.import(file: File, successCallback?: Function, errorCallback?: Function, importOptions?: GC.Spread.Sheets.ImportOptions)
  /**
  * Imports the object state from the excel or ssJson or csv file.
  * @param {File} file - The ssJson or csv or Excel file for import.
  * @param {function} [successCallBack] - The success callback when import file complete, accept json as argument. ???
  * @param {function} [errorCallBack] - The error callback when import file got error.
  * @param {GC.Spread.Sheets.ImportOptions} [importOptions] - The import options.
  * @example
  * //This example uses the import method.
  * //Get file blob.
  * var file = document.getElementById("importFileName").files[0];
  * // import
  * spread.import(file, function () {
  *    // success callback to do something
  * }, function (e) {
  *    console.log(e); // error callback
  * }, {
  *    fileType: GC.Spread.Sheets.FileType.excel,
  *    // The importing excel file type ('XLSX' | 'XLSM' | 'XLTM'), default by XLSX.
  *    excelFileType: 'XLSM'
  * });
  */
  Workbook.prototype.import = function (file: File, successCallback?, errorCallback?, importOptions?: ImportOptions);
}

GC.Spread.Sheets.SaveOptions

///* typedef GC.Spread.Sheets.SaveOptions
/**
 * @typedef GC.Spread.Sheets.SaveOptions
 * @property {boolean} [includeBindingSource] - Whether to include the binding source when do save, default false.
 * @property {boolean} [includeStyles] - Whether to include the style when do save, default true.
 * @property {boolean} [includeFormulas] - Whether to include the formula when do save, default true.
 * @property {boolean} [saveAsView] - Whether to ignore the format string when do save, default false.
 * @property {boolean} [includeAutoMergedCells] - Whether to include the automatically merged cells when do save, default false.
 * @property {boolean} [includeCalcModelCache] - Whether to include the extra data of calculation. Can be faster when open the file with those data, default false.
 * @property {boolean} [includeUnusedNames] - Whether to include the unused custom name when do save, default true.
 * @property {boolean} [includeEmptyRegionCells] - Whether to include any empty cells(cells with no data or only style) outside the used data range, default true.
 * @property {boolean} [saveR1C1Formula] - Whether to save the r1c1 formula in the file, only works in sjs file type, default false.
 */

GC.Spread.Sheets.OpenOptions

///* typedef GC.Spread.Sheets.OpenOptions
/**
 * @typedef GC.Spread.Sheets.OpenOptions
 * @property {boolean} [includeStyles] - Whether to include the style when loading, default true.
 * @property {boolean} [includeFormulas] - Whether to include the formula when loading, default true.
 * @property {boolean} [fullRecalc] - Whether to calculate after loading the json data, false by default.
 * @property {boolean} [dynamicReferences] - Whether to calculate functions with dynamic reference, default true.
 * @property {boolean} [calcOnDemand] - Whether to calculate formulas only when they are demanded, default false.
 * @property {boolean} [incrementalCalculation] - Whether to incremental calculate formulas without blocking UI, default false.
 * @property {boolean} [includeUnusedStyles] - Whether to include the name style when converting excel xml to the json, default true.
 * @property {GC.Spread.Sheets.OpenMode} [openMode] - The open mode of normal, lazy and incremental. By default is normal.
 * @property {GC.Spread.Sheets.ProgressFunctionType} [progress] - The progress callback function for each open mode.
 */

 ///* enum GC.Spread.Sheets.OpenMode
/**
 * The open mode for open sjs function.
 * @enum {number}
 */
 enum OpenMode {
    /**
    * normal open mode, without lazy and incremental. When opening file, UI and UI event could be refreshed and responsive at specific time points.
    */
    normal = 0,
    /**
    * lazy open mode. When opening file, only the active sheet will be loaded directly. Other sheets will be loaded only when they are be used.
    */
    lazy = 1,
    /**
    * incremental open mode. When opening file, UI and UI event could be refreshed and responsive directly.
    */
    incremental = 2
}

///* typedef GC.Spread.Sheets.ProgressFunctionType
/**
 * @typedef GC.Spread.Sheets.ProgressFunctionType
 * @param {object} progressArgs - the progress arguments.
 * @param {string} [progressArgs.sheetName] - the current loading sheet's name.
 * @param {string} progressArgs.step - the current loading step.
 * @param {number} progressArgs.progress - the current loading progress, from 0 - 1.
 * @returns {void}
 * @description The callback when of the incremental loading progress.
 */
export type ProgressFunctionType = (progressArgs: ProgressArgs) => void;

GC.Spread.Sheets.ImportOptions

///* typedef GC.Spread.Sheets.ImportOptions
/**
 * @typedef {GC.Spread.Sheets.FileOptions & (GC.Spread.Sheets.ImportCsvOptions | GC.Spread.Sheets.ImportSSJsonOptions | GC.Spread.Sheets.ImportXlsxOptions)} GC.Spread.Sheets.ImportOptions - The options for import function. */
/**
 GC.Spread.Sheets.FileOptions & (GC.Spread.Sheets.ImportCsvOptions | GC.Spread.Sheets.ImportSSJsonOptions | GC.Spread.Sheets.ImportXlsxOptions)
*/

///* typedef GC.Spread.Sheets.FileOptions
/**
 * @typedef GC.Spread.Sheets.FileOptions - The file options for export.
 * @property {GC.Spread.Sheets.FileType} fileType - The file type.
 */
/**
{
    fileType: GC.Spread.Sheets.FileType
}
*/

GC.Spread.Sheets.ExportOptions

///* typedef GC.Spread.Sheets.ExportOptions
/**
 * @typedef {GC.Spread.Sheets.FileOptions & (GC.Spread.Sheets.ExportCsvOptions | GC.Spread.Sheets.ExportSSJsonOptions | GC.Spread.Sheets.ExportXlsxOptions)} GC.Spread.Sheets.ExportOptions - The options for export function.
 */
/**
 GC.Spread.Sheets.FileOptions & (GC.Spread.Sheets.ExportCsvOptions | GC.Spread.Sheets.ExportSSJsonOptions | GC.Spread.Sheets.ExportXlsxOptions)
*/

///* typedef GC.Spread.Sheets.FileOptions
/**
 * @typedef GC.Spread.Sheets.FileOptions - The file options for export.
 * @property {GC.Spread.Sheets.FileType} fileType - The file type.
 */
/**
{
    fileType: GC.Spread.Sheets.FileType
}
*/

GC.Spread.Sheets.ExcelFileType

///*typedef GC.Spread.Sheets.ExcelFileType
/**
 * @typedef GC.Spread.Sheets.ExcelFileType
 * @type {"XLSX" | "XLSM" | "XLTM"}
 * @description Represents the fileType of Excel.
 */
/**
     "XLSX" | "XLSM" | "XLTM"
*/

GC.Spread.Sheets.ImportXlsxOptions

///* typedef GC.Spread.Sheets.ImportXlsxOptions
/**
 * @typedef GC.Spread.Sheets.ImportXlsxOptions
 * @property {boolean} [includeStyles] - Whether to include the style when loading, default true.
 * @property {boolean} [includeFormulas] - Whether to include the formula when loading, default true.
 * @property {boolean} [frozenColumnsAsRowHeaders] - Whether to treat the frozen columns as row headers when loading, default false.
 * @property {boolean} [frozenRowsAsColumnHeaders] - Whether to treat the frozen rows as column headers when loading, default false.
 * @property {boolean} [fullRecalc] - Whether to calculate after loading the json data, false by default.
 * @property {boolean} [dynamicReferences] - Whether to calculate functions with dynamic reference, default true.
 * @property {boolean} [calcOnDemand] - Whether to calculate formulas only when they are demanded, default false.
 * @property {boolean} [incrementalCalculation] - Whether to incremental calculate formulas without blocking UI, default false.
 * @property {boolean} [includeUnusedStyles] - Whether to include the name style when converting excel xml to the json, default true.
 * @property {boolean} [convertSheetTableToDataTable] - Whether to convert the sheet tables to data manager tables, default false.
 * @property {GC.Spread.Sheets.OpenMode} [openMode] - The open mode of normal, lazy and incremental. By default is lazy.
 * @property {GC.Spread.Sheets.ProgressFunctionType} [progress] - The progress callback function for each open mode.
 * @property {GC.Spread.Sheets.ExcelFileType} [excelFileType] - The importing excel file type ('XLSX' | 'XLSM' | 'XLTM'), default by XLSX.
 */
/**
{
    includeStyles?: boolean;
    frozenColumnsAsRowHeaders?: boolean;
    frozenRowsAsColumnHeaders?: boolean;
    includeFormulas?: boolean;
    fullRecalc?: boolean;
    dynamicReferences?: boolean;
    calcOnDemand?: boolean;
    includeUnusedStyles?: boolean;
    convertSheetTableToDataTable?: boolean;
    incrementalCalculation?: boolean;
    openMode?: GC.Spread.Sheets.OpenMode;
    progress?: GC.Spread.Sheets.ProgressFunctionType,
    excelFileType?: GC.Spread.Sheets.ExcelFileType
}
*/

GC.Spread.Sheets.ExportXlsxOptions

///* typedef GC.Spread.Sheets.ExportXlsxOptions
/**
 * @typedef GC.Spread.Sheets.ExportXlsxOptions
 * @property {boolean} [includeBindingSource] - Whether to include the binding source when do save, default false.
 * @property {boolean} [includeStyles] - Whether to include the style when do save, default true.
 * @property {boolean} [includeFormulas] - Whether to include the formula when do save, default true.
 * @property {boolean} [saveAsView] - Whether to ignore the format string when do save, default false.
 * @property {boolean} [rowHeadersAsFrozenColumns] - Whether to treat the row headers as frozen columns when do save, default false.
 * @property {boolean} [columnHeadersAsFrozenRows] - Whether to treat the column headers as frozen rows when do save, default false.
 * @property {boolean} [includeAutoMergedCells] - Whether to include the automatically merged cells when do save, default false.
 * @property {boolean} [includeUnusedNames] - Whether to include the unused custom name when do save, default true.
 * @property {boolean} [includeEmptyRegionCells] - Whether to include any empty cells(cells with no data or only style) outside the used data range, default true.
 * @property {boolean} [losslessEditing] - Whether to include lossless editing content, default true.
 * @property {GC.Spread.Sheets.ExcelFileType} [excelFileType] - The exporting excel file type ('XLSX' | 'XLSM' | 'XLTM'), default by XLSX.
 */
/**
{
    includeBindingSource?: boolean;
    includeStyles?: boolean;
    includeFormulas?: boolean;
    saveAsView?: boolean;
    rowHeadersAsFrozenColumns?: boolean;
    columnHeadersAsFrozenRows?: boolean;
    includeUnusedNames?: boolean;
    includeEmptyRegionCells?: boolean;
    includeAutoMergedCells?: boolean;
    losslessEditing?: boolean;
    excelFileType?: GC.Spread.Sheets.ExcelFileType;
}
*/

GC.Spread.Sheets.ImportCsvOptions

///* typedef GC.Spread.Sheets.ImportCsvOptions
/**
 * @typedef GC.Spread.Sheets.ImportCsvOptions
 * @property {string} [encoding] - The csv encoding type, the default encoding type is 'UTF-8'.
 * @property {string} [rowDelimiter] - The row delimiter that is appended to the end of the row, the default row delimiter is '\r\n'.
 * @property {string} [columnDelimiter] - The column delimiter that is appended to the end of the column, the default column delimiter is ','.
 */
/**
{
    rowDelimiter?: string;
    columnDelimiter?: string;
    encoding?: string;
}
*/

.Spread.Sheets.ExportCsvOptions

///* typedef GC.Spread.Sheets.ExportCsvOptions
/**
 * @typedef GC.Spread.Sheets.ExportCsvOptions
 * @property {string} [encoding] - The csv encoding type, the default encoding type is 'UTF-8'.
 * @property {string} [rowDelimiter] - The row delimiter that is appended to the end of the row, the default row delimiter is '\r\n'.
 * @property {string} [columnDelimiter] - The column delimiter that is appended to the end of the column, the default column delimiter is ','.
 * @property {object} [range] - The range info.
 * @param {number} [range.sheetIndex] - The sheet index, the default sheet index is current active sheet index.
 * @param {number} [range.row] - The start row, the default row index is 0.
 * @param {number} [range.column] - The start column, the default column index is 0.
 * @param {number} [range.rowCount] - The row count, the default row count is current active sheet row count.
 * @param {number} [range.columnCount] - The column count, the default column count is current active sheet column count.

 */
/**
{
    encoding?: string;
    rowDelimiter?: string;
    columnDelimiter?: string;
    range?: {
        sheetIndex: number;
        row: number;
        column: number;
        rowCount: number;
        columnCount: number;
    }
}
*/

GC.Spread.Sheets.ImportSSJsonOptions

///* typedef GC.Spread.Sheets.ImportSSJsonOptions
/**
 * @typedef GC.Spread.Sheets.ImportSSJsonOptions
 * @property {boolean} [includeStyles] - Whether to include the style when converting json to the workbook, default true.
 * @property {boolean} [includeFormulas] - Whether to include the formula when converting json to the workbook, default true.
 * @property {boolean} [frozenColumnsAsRowHeaders] - Whether to treat the frozen columns as row headers when converting json to the workbook, default false.
 * @property {boolean} [frozenRowsAsColumnHeaders] - Whether to treat the frozen rows as column headers when converting json to the workbook, default false.
 * @property {boolean} [fullRecalc] - Whether to do full recalculation after loading the json data, default true.
 * @property {boolean | object} [incrementalLoad] - Whether to use the incremental loading or the callbacks of incremental loading when converting json to the workbook, default false.
 * @param {function} [incrementalLoad.loading] - The callback when of the incremental loading progress.
 * @param {function} [incrementalLoad.loaded] - The callback when of the incremental loading finished.
 */
/**
{
    includeStyles?: boolean;
    incrementalLoad?: any;
    frozenColumnsAsRowHeaders?: boolean;
    frozenRowsAsColumnHeaders?: boolean;
    includeFormulas?: boolean;
    fullRecalc?: boolean;
}
*/

GC.Spread.Sheets.ExportSSJsonOptions

///* typedef GC.Spread.Sheets.ExportSSJsonOptions
/**
 * @typedef GC.Spread.Sheets.ExportSSJsonOptions
 * @property {boolean} [includeBindingSource] - Whether to include the binding source when converting the workbook to json, default false.
 * @property {boolean} [includeStyles] - Whether to include the style when converting the workbook to json, default true.
 * @property {boolean} [includeFormulas] - Whether to include the formula when converting the workbook to json, default true.
 * @property {boolean} [saveAsView] - Whether to ignore the format string when converting the workbook to json, default false.
 * @property {boolean} [rowHeadersAsFrozenColumns] - Whether to treat the row headers as frozen columns when converting the workbook to json, default false.
 * @property {boolean} [columnHeadersAsFrozenRows] - Whether to treat the column headers as frozen rows when converting the workbook to json, default false.
 * @property {boolean} [includeAutoMergedCells] - Whether to include the automatically merged cells when converting the workbook to json, default false.
 */
/**
{
    includeBindingSource?: boolean;
    includeStyles?: boolean;
    includeFormulas?: boolean;
    saveAsView?: boolean;
    rowHeadersAsFrozenColumns?: boolean;
    columnHeadersAsFrozenRows?: boolean;
    includeAutoMergedCells?: boolean;
}
*/
In order to use the SpreadJS File Format feature, you need to add the related js file link into the document's head section below the Spread link. For example: SpreadJS supports opening and saving sjs file formats. It also supports importing and exporting xlsx, xlsm, xltm, ssjson, and csv file formats. For example: class GC.Spread.Sheets.Workbook GC.Spread.Sheets.SaveOptions GC.Spread.Sheets.OpenOptions GC.Spread.Sheets.ImportOptions GC.Spread.Sheets.ExportOptions GC.Spread.Sheets.ExcelFileType GC.Spread.Sheets.ImportXlsxOptions GC.Spread.Sheets.ExportXlsxOptions GC.Spread.Sheets.ImportCsvOptions .Spread.Sheets.ExportCsvOptions GC.Spread.Sheets.ImportSSJsonOptions GC.Spread.Sheets.ExportSSJsonOptions
import { Component, NgModule, enableProdMode } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { FormsModule } from '@angular/forms'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { SpreadSheetsModule } from '@mescius/spread-sheets-angular'; import GC from '@mescius/spread-sheets'; import '@mescius/spread-sheets-print'; import '@mescius/spread-sheets-io'; import '@mescius/spread-sheets-shapes'; import '@mescius/spread-sheets-charts'; import '@mescius/spread-sheets-slicers'; import '@mescius/spread-sheets-pivot-addon'; import '@mescius/spread-sheets-reportsheet-addon'; import "@mescius/spread-sheets-tablesheet"; import "@mescius/spread-sheets-ganttsheet"; import './styles.css'; declare let orderDataSource: any; declare var saveAs: any; @Component({ selector: 'app-component', templateUrl: 'src/app.component.html' }) export class AppComponent { spread: GC.Spread.Sheets.Workbook; hostStyle = { width: '100%', height: '100%', overflow: 'hidden', float: 'left' }; selectedFile: File = null; openFileType: string = ""; saveFileType: string = "sjs"; excelFileType: string = 'XLSX'; openOptions = { openMode: 0, includeStyles: true, includeFormulas: true, frozenColumnsAsRowHeaders: false, frozenRowsAsColumnHeaders: false, fullRecalc: false, dynamicReferences: true, calcOnDemand: false, includeUnusedStyles: true, convertSheetTableToDataTable: false, incrementalLoading: false, encoding: "UTF-8", rowDelimiter: "\r\n", columnDelimiter: "," }; saveOptions = { includeBindingSource: false, includeStyles: true, includeFormulas: true, saveAsView: false, rowHeadersAsFrozenColumns: false, columnHeadersAsFrozenRows: false, includeAutoMergedCells: false, includeCalcModelCache: false, includeUnusedNames: true, includeEmptyRegionCells: true, losslessEditing: true, encoding: "UTF-8", rowDelimiter: "\r\n", columnDelimiter: ",", sheetIndex: 0, row: 0, column: 0, rowCount: 200, columnCount: 20, }; openOptionsConfig = { sjs: [ { propName: "openMode", type: "select", displayText: "OpenMode", options: [{name: 'normal', value: 0}, {name: 'lazy', value: 1}, {name: 'incremental', value: 2}], default: 0 }, { propName: "includeStyles", type: "boolean", default: true }, { propName: "includeFormulas", type: "boolean", default: true }, { propName: "fullRecalc", type: "boolean", default: false }, { propName: "dynamicReferences", type: "boolean", default: true }, { propName: "calcOnDemand", type: "boolean", default: false }, { propName: "includeUnusedStyles", type: "boolean", default: true }, ], xlsx: [ { propName: "openMode", type: "select", displayText: "OpenMode", options: [{name: 'normal', value: 0}, {name: 'lazy', value: 1}, {name: 'incremental', value: 2}], default: 0 }, { propName: "includeStyles", type: "boolean", default: true }, { propName: "includeFormulas", type: "boolean", default: true }, { propName: "frozenColumnsAsRowHeaders", type: "boolean", default: false }, { propName: "frozenRowsAsColumnHeaders", type: "boolean", default: false }, { propName: "fullRecalc", type: "boolean", default: false }, { propName: "dynamicReferences", type: "boolean", default: true }, { propName: "calcOnDemand", type: "boolean", default: false }, { propName: "includeUnusedStyles", type: "boolean", default: true }, { propName: "convertSheetTableToDataTable", type: "boolean", default: false }, ], ssjson: [ { propName: "includeStyles", type: "boolean", default: true }, { propName: "includeFormulas", type: "boolean", default: true }, { propName: "frozenColumnsAsRowHeaders", type: "boolean", default: false }, { propName: "frozenRowsAsColumnHeaders", type: "boolean", default: false }, { propName: "fullRecalc", type: "boolean", default: false }, { propName: "incrementalLoading", type: "boolean", default: false } ], csv: [ { propName: "encoding", type: "string", default: "UTF-8" }, { propName: "rowDelimiter", type: "string", default: "\r\n" }, { propName: "columnDelimiter", type: "string", default: "," } ] }; saveOptionsConfig = { sjs: [ { propName: "includeBindingSource", type: "boolean", default: false }, { propName: "includeStyles", type: "boolean", default: true }, { propName: "includeFormulas", type: "boolean", default: true }, { propName: "saveAsView", type: "boolean", default: false }, { propName: "includeAutoMergedCells", type: "boolean", default: false }, { propName: "includeCalcModelCache", type: "boolean", default: false }, { propName: "saveR1C1Formula", type: "boolean", default: false }, { propName: "includeUnusedNames", type: "boolean", default: true }, { propName: "includeEmptyRegionCells", type: "boolean", default: true }, ], xlsx: [ { propName: "includeBindingSource", type: "boolean", default: false }, { propName: "includeStyles", type: "boolean", default: true }, { propName: "includeFormulas", type: "boolean", default: true }, { propName: "saveAsView", type: "boolean", default: false }, { propName: "rowHeadersAsFrozenColumns", type: "boolean", default: false }, { propName: "columnHeadersAsFrozenRows", type: "boolean", default: false }, { propName: "includeAutoMergedCells", type: "boolean", default: false }, { propName: "includeUnusedNames", type: "boolean", default: true }, { propName: "includeEmptyRegionCells", type: "boolean", default: true }, { propName: "losslessEditing", type: "boolean", default: true }, ], ssjson: [ { propName: "includeBindingSource", type: "boolean", default: false }, { propName: "includeStyles", type: "boolean", default: true }, { propName: "includeFormulas", type: "boolean", default: true }, { propName: "saveAsView", type: "boolean", default: false }, { propName: "rowHeadersAsFrozenColumns", type: "boolean", default: false }, { propName: "columnHeadersAsFrozenRows", type: "boolean", default: false }, { propName: "includeAutoMergedCells", type: "boolean", default: false }, ], csv: [ { propName: "encoding", type: "string", default: "UTF-8" }, { propName: "rowDelimiter", type: "string", default: "\r\n" }, { propName: "columnDelimiter", type: "string", default: "," }, { propName: "sheetIndex", type: "number", default: 0 }, { propName: "row", type: "number", default: 0 }, { propName: "column", type: "number", default: 0 }, { propName: "rowCount", type: "number", default: 200 }, { propName: "columnCount", type: "number", default: 20 }, ] }; constructor() { } initSpread($event: any) { this.spread = $event.spread; var statusBar = new GC.Spread.Sheets.StatusBar.StatusBar(document.getElementById('statusBar')); statusBar.bind(this.spread); } selectedFileChange(e: any) { this.selectedFile = e.target.files[0]; this.openFileType = this.getFileType(this.selectedFile); } open() { var file = this.selectedFile; if (!file) { return; } var fileType = this.getFileType(file); var options = this.getOptions('open'); if (fileType === 'sjs') { this.spread.open(file, function() {}, function() {}, options); } else { this.spread.import(file, function() {}, function() {}, options); } } save() { var fileType = this.saveFileType; var fileName = 'export.' + (fileType === 'xlsx' ? this.excelFileType.toLowerCase() : fileType); var options: any = this.getOptions('save'); if (fileType === 'sjs') { this.spread.save(function(blob) { saveAs(blob, fileName); }, function() {}, options); } else { if (fileType === 'csv') { var { sheetIndex, row, rowCount, column, columnCount } = options; options.range = { sheetIndex: sheetIndex, row: row, rowCount: rowCount, column: column, columnCount: columnCount, }; } options.fileType = this.mapExportFileType(fileType); this.spread.export(function(blob) { saveAs(blob, fileName); }, function() {}, options); } } getOptions (mode: string) { let optionsConfig; let optionsValue: any; if (mode === 'open') { optionsConfig = this.openOptionsConfig[this.openFileType]; optionsValue = this.openOptions; } else { optionsConfig = this.saveOptionsConfig[this.saveFileType]; optionsValue = this.saveOptions; } let options = {}; optionsConfig.forEach((prop: any) => { let v = optionsValue[prop.propName]; if (prop.type === 'number') { v = +v; } options[prop.propName] = v; }); if (mode === 'save' && this.saveFileType === 'xlsx') { options['excelFileType'] = this.excelFileType; } return options; } getFileType(file: File) { if (!file) { return; } var fileName = file.name; var extensionName = fileName.substring(fileName.lastIndexOf(".") + 1); if (extensionName === 'sjs') { return 'sjs'; } else if (extensionName === 'xlsx' || extensionName === 'xlsm' || extensionName === 'xltm') { return 'xlsx'; } else if (extensionName === 'ssjson' || extensionName === 'json') { return 'ssjson'; } else if (extensionName === 'csv') { return 'csv'; } } mapExportFileType (fileType: string) { if (fileType === 'ssjson') { return GC.Spread.Sheets.FileType.ssjson; } else if (fileType === 'csv') { return GC.Spread.Sheets.FileType.csv; } return GC.Spread.Sheets.FileType.excel; } needShow(mode: string, propName: string) { let options = mode === 'open' ? this.openOptionsConfig[this.openFileType] : this.saveOptionsConfig[this.saveFileType]; return options && options.find((p: any) => p.propName === propName); } } @NgModule({ imports: [BrowserModule, SpreadSheetsModule, FormsModule], declarations: [AppComponent], exports: [AppComponent], bootstrap: [AppComponent] }) export class AppModule { } enableProdMode(); // Bootstrap application with hash style navigation and global services. platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/spread/source/js/FileSaver.js" type="text/javascript"></script> <!-- Polyfills --> <script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script> <script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script> <!-- SystemJS --> <script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script> <script src="systemjs.config.js"></script> <script> // workaround to load 'rxjs/operators' from the rxjs bundle System.import('rxjs').then(function (m) { System.import('@angular/compiler'); System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators)); System.import('$DEMOROOT$/en/lib/angular/license.ts'); System.import('./src/app.component'); }); </script> </head> <body> <app-component></app-component> </body> </html>
<div class="sample-tutorial"> <div class="sample-container"> <div class="sample-spreadsheets"> <gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)"> <gc-worksheet> </gc-worksheet> </gc-spread-sheets> </div> <div id="statusBar"></div> </div> <div class="options-container"> <div class="option-row"> <div class="inputContainer"> <input id="selectedFile" type="file" accept=".sjs, .xlsx, .xlsm, .xltm, .ssjson, .json, .csv" (change)="selectedFileChange($event)" /> <button class="settingButton" id="open" (click)="open()">Open</button> <div class="open-options"> <div class="item" *ngIf="needShow('open', 'openMode')"> <label for="open-openMode">OpenMode</label> <select id="open-openMode" [(ngModel)]="openOptions.openMode"> <option value="0">normal</option> <option value="1">lazy</option> <option value="2">incremental</option> </select> </div> <div class="item" *ngIf="needShow('open', 'openMode')" > <input type="checkbox" id="open-includeStyles" [(ngModel)]="openOptions.includeStyles"/> <label for="open-includeStyles">includeStyles</label> </div> <div class="item" *ngIf="needShow('open', 'includeFormulas')" > <input type="checkbox" id="open-includeFormulas" [(ngModel)]="openOptions.includeFormulas"/> <label for="open-includeFormulas">includeFormulas</label> </div> <div class="item" *ngIf="needShow('open', 'frozenColumnsAsRowHeaders')" > <input type="checkbox" id="open-frozenColumnsAsRowHeaders" [(ngModel)]="openOptions.frozenColumnsAsRowHeaders"/> <label for="open-frozenColumnsAsRowHeaders">frozenColumnsAsRowHeaders</label> </div> <div class="item" *ngIf="needShow('open', 'frozenRowsAsColumnHeaders')" > <input type="checkbox" id="open-frozenRowsAsColumnHeaders" [(ngModel)]="openOptions.frozenRowsAsColumnHeaders"/> <label for="open-frozenRowsAsColumnHeaders">frozenRowsAsColumnHeaders</label> </div> <div class="item" *ngIf="needShow('open', 'fullRecalc')" > <input type="checkbox" id="open-fullRecalc" [(ngModel)]="openOptions.fullRecalc"/> <label for="open-fullRecalc">fullRecalc</label> </div> <div class="item" *ngIf="needShow('open', 'dynamicReferences')" > <input type="checkbox" id="open-dynamicReferences" [(ngModel)]="openOptions.dynamicReferences"/> <label for="open-dynamicReferences">dynamicReferences</label> </div> <div class="item" *ngIf="needShow('open', 'calcOnDemand')" > <input type="checkbox" id="open-calcOnDemand" [(ngModel)]="openOptions.calcOnDemand"/> <label for="open-calcOnDemand">calcOnDemand</label> </div> <div class="item" *ngIf="needShow('open', 'includeUnusedStyles')" > <input type="checkbox" id="open-includeUnusedStyles" [(ngModel)]="openOptions.includeUnusedStyles"/> <label for="open-includeUnusedStyles">includeUnusedStyles</label> </div> <div class="item" *ngIf="needShow('open', 'convertSheetTableToDataTable')" > <input type="checkbox" id="open-convertSheetTableToDataTable" [(ngModel)]="openOptions.convertSheetTableToDataTable"/> <label for="open-convertSheetTableToDataTable">convertSheetTableToDataTable</label> </div> <div class="item" *ngIf="needShow('open', 'incrementalLoading')" > <input type="checkbox" id="open-incrementalLoading" [(ngModel)]="openOptions.incrementalLoading"/> <label for="open-incrementalLoading">incrementalLoading</label> </div> <div class="item" *ngIf="needShow('open', 'encoding')" > <label for="open-encoding">encoding</label> <input type="text" id="open-encoding" [(ngModel)]="openOptions.encoding"/> </div> <div class="item" *ngIf="needShow('open', 'rowDelimiter')" > <label for="open-rowDelimiter">rowDelimiter</label> <input type="text" id="open-rowDelimiter" [(ngModel)]="openOptions.rowDelimiter"/> </div> <div class="item" *ngIf="needShow('open', 'columnDelimiter')" > <label for="open-columnDelimiter">columnDelimiter</label> <input type="text" id="open-columnDelimiter" [(ngModel)]="openOptions.columnDelimiter"/> </div> </div> </div> <div class="inputContainer"> <label for="saveFileType">FileType:</label> <select id="saveFileType" [(ngModel)]="saveFileType"> <option value="sjs">SJS</option> <option value="xlsx">Excel</option> <option value="ssjson">SSJson</option> <option value="csv">Csv</option> </select> <button class="settingButton" id="save" (click)="save()">Save</button> <div class="excelFileTypeContainer" *ngIf="saveFileType === 'xlsx'"> <label for="fileType">Excel FileType:</label> <div> <select id="saveExcelFileType" [(ngModel)]="excelFileType"> <option value="XLSX">Workbook (*.xlsx)</option> <option value="XLSM">Macro-Enabled Workbook (*.xlsm)</option> <option value="XLTM">Macro-Enabled Template (*.xltm)</option> </select> </div> </div> <div class="save-options"> <div class="item" *ngIf="needShow('save', 'includeBindingSource')" > <input type="checkbox" id="save-includeBindingSource" [(ngModel)]="saveOptions.includeBindingSource"/> <label for="save-includeBindingSource">includeBindingSource</label> </div> <div class="item" *ngIf="needShow('save', 'includeStyles')" > <input type="checkbox" id="save-includeStyles" [(ngModel)]="saveOptions.includeStyles"/> <label for="save-includeStyles">includeStyles</label> </div> <div class="item" *ngIf="needShow('save', 'includeFormulas')" > <input type="checkbox" id="save-includeFormulas" [(ngModel)]="saveOptions.includeFormulas"/> <label for="save-includeFormulas">includeFormulas</label> </div> <div class="item" *ngIf="needShow('save', 'saveAsView')" > <input type="checkbox" id="save-saveAsView" [(ngModel)]="saveOptions.saveAsView"/> <label for="save-saveAsView">saveAsView</label> </div> <div class="item" *ngIf="needShow('save', 'rowHeadersAsFrozenColumns')" > <input type="checkbox" id="save-rowHeadersAsFrozenColumns" [(ngModel)]="saveOptions.rowHeadersAsFrozenColumns"/> <label for="save-rowHeadersAsFrozenColumns">rowHeadersAsFrozenColumns</label> </div> <div class="item" *ngIf="needShow('save', 'columnHeadersAsFrozenRows')" > <input type="checkbox" id="save-columnHeadersAsFrozenRows" [(ngModel)]="saveOptions.columnHeadersAsFrozenRows"/> <label for="save-columnHeadersAsFrozenRows">columnHeadersAsFrozenRows</label> </div> <div class="item" *ngIf="needShow('save', 'includeAutoMergedCells')" > <input type="checkbox" id="save-includeAutoMergedCells" [(ngModel)]="saveOptions.includeAutoMergedCells"/> <label for="save-includeAutoMergedCells">includeAutoMergedCells</label> </div> <div class="item" *ngIf="needShow('save', 'includeCalcModelCache')" > <input type="checkbox" id="save-includeCalcModelCache" [(ngModel)]="saveOptions.includeCalcModelCache"/> <label for="save-includeCalcModelCache">includeCalcModelCache</label> </div> <div class="item" *ngIf="needShow('save', 'saveR1C1Formula')" > <input type="checkbox" id="save-saveR1C1Formula" [(ngModel)]="saveOptions.saveR1C1Formula"/> <label for="save-saveR1C1Formula">saveR1C1Formula</label> </div> <div class="item" *ngIf="needShow('save', 'includeUnusedNames')" > <input type="checkbox" id="save-includeUnusedNames" [(ngModel)]="saveOptions.includeUnusedNames"/> <label for="save-includeUnusedNames">includeUnusedNames</label> </div> <div class="item" *ngIf="needShow('save', 'includeEmptyRegionCells')" > <input type="checkbox" id="save-includeEmptyRegionCells" [(ngModel)]="saveOptions.includeEmptyRegionCells"/> <label for="save-includeEmptyRegionCells">includeEmptyRegionCells</label> </div> <div class="item" *ngIf="needShow('save', 'losslessEditing')" > <input type="checkbox" id="save-losslessEditing" [(ngModel)]="saveOptions.losslessEditing"/> <label for="save-losslessEditing">losslessEditing</label> </div> <div class="item" *ngIf="needShow('save', 'encoding')" > <label for="save-encoding">encoding</label> <input type="text" id="save-encoding" [(ngModel)]="saveOptions.encoding"/> </div> <div class="item" *ngIf="needShow('save', 'rowDelimiter')" > <label for="save-rowDelimiter">rowDelimiter</label> <input type="text" id="save-rowDelimiter" [(ngModel)]="saveOptions.rowDelimiter"/> </div> <div class="item" *ngIf="needShow('save', 'columnDelimiter')" > <label for="save-columnDelimiter">columnDelimiter</label> <input type="text" id="save-columnDelimiter" [(ngModel)]="saveOptions.columnDelimiter"/> </div> <div class="item" *ngIf="needShow('save', 'sheetIndex')" > <label for="save-sheetIndex">sheetIndex</label> <input type="number" id="save-sheetIndex" [(ngModel)]="saveOptions.sheetIndex"/> </div> <div class="item" *ngIf="needShow('save', 'row')" > <label for="save-row">row</label> <input type="number" id="save-row" [(ngModel)]="saveOptions.row"/> </div> <div class="item" *ngIf="needShow('save', 'column')" > <label for="save-column">column</label> <input type="number" id="save-column" [(ngModel)]="saveOptions.column"/> </div> <div class="item" *ngIf="needShow('save', 'rowCount')" > <label for="save-rowCount">rowCount</label> <input type="number" id="save-rowCount" [(ngModel)]="saveOptions.rowCount"/> </div> <div class="item" *ngIf="needShow('save', 'columnCount')" > <label for="save-columnCount">columnCount</label> <input type="number" id="save-columnCount" [(ngModel)]="saveOptions.columnCount"/> </div> </div> </div> </div> </div> </div>
body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-container { width: calc(100% - 280px); height: 100%; float: left; } .sample-spreadsheets { width: 100%; height: calc(100% - 25px); overflow: hidden; } #statusBar { bottom: 0; height: 25px; width: 100%; position: relative; } .options-container { float: right; width: 280px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .sample-options { z-index: 1000; } .inputContainer { width: 100%; height: auto; border: 1px solid #eee; padding: 6px; margin-bottom: 10px; box-sizing: border-box; } .settingButton { color: #fff; background: #82bc00; outline: 0; line-height: 1.5715; position: relative; display: inline-block; font-weight: 400; white-space: nowrap; text-align: center; height: 32px; padding: 4px 15px; font-size: 14px; border-radius: 2px; user-select: none; cursor: pointer; border: 1px solid #82bc00; box-sizing: border-box; margin-bottom: 10px; margin-top: 10px; } .settingButton:hover { color: #fff; border-color: #88b031; background: #88b031; } .options-title { font-weight: bold; margin: 4px 2px; } #selectedFile { width: 180px; } #saveFileType { width: 120px; height: 31px; } .open-options .item { margin: 5px 0px; display: flex; } .save-options .item { margin: 5px 0px; display: flex; } label { margin-left: 3px; } select, input[type="text"], input[type="number"] { display: inline-block; margin-left: auto; width: 120px; font-weight: 400; outline: 0; line-height: 1.5715; border-radius: 2px; border: 1px solid #F4F8EB; box-sizing: border-box; } .excelFileTypeContainer { margin-bottom: 10px; } #saveExcelFileType { margin: 10px 0; width: 100%; }
(function (global) { System.config({ transpiler: 'ts', typescriptOptions: { tsconfig: true }, meta: { 'typescript': { "exports": "ts" }, '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { 'core-js': 'npm:core-js/client/shim.min.js', 'zone': 'npm:zone.js/fesm2015/zone.min.js', 'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js', '@angular/core': 'npm:@angular/core/fesm2022', '@angular/common': 'npm:@angular/common/fesm2022/common.mjs', '@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs', '@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs', '@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs', '@angular/router': 'npm:@angular/router/fesm2022/router.mjs', '@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs', 'jszip': 'npm:jszip/dist/jszip.min.js', 'typescript': 'npm:typescript/lib/typescript.js', 'ts': './plugin.js', 'tslib':'npm:tslib/tslib.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js', '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-print': 'npm:@mescius/spread-sheets-print/index.js', '@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js', '@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js', '@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js', '@mescius/spread-sheets-slicers': 'npm:@mescius/spread-sheets-slicers/index.js', '@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js', '@mescius/spread-sheets-reportsheet-addon': 'npm:@mescius/spread-sheets-reportsheet-addon/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js', '@mescius/spread-sheets-ganttsheet': 'npm:@mescius/spread-sheets-ganttsheet/index.js', '@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'ts' }, rxjs: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' }, "node_modules/@angular": { defaultExtension: 'mjs' }, "@mescius/spread-sheets-angular": { defaultExtension: 'mjs' }, '@angular/core': { defaultExtension: 'mjs', main: 'core.mjs' } } }); })(this);

In order to use the SpreadJS File Format feature, you need to add the related js file link into the document's head section below the Spread link. For example:
SpreadJS supports opening and saving sjs file formats. It also supports importing and exporting xlsx, xlsm, xltm, xltx, ssjson, and csv file formats.
For example:
class GC.Spread.Sheets.Workbook
GC.Spread.Sheets.SaveOptions
GC.Spread.Sheets.OpenOptions
GC.Spread.Sheets.ImportOptions
GC.Spread.Sheets.ExportOptions
GC.Spread.Sheets.ExcelFileType
GC.Spread.Sheets.ImportXlsxOptions
GC.Spread.Sheets.ExportXlsxOptions
GC.Spread.Sheets.ImportCsvOptions
.Spread.Sheets.ExportCsvOptions
GC.Spread.Sheets.ImportSSJsonOptions
GC.Spread.Sheets.ExportSSJsonOptions
<template>
<div class="sample-tutorial">
<div class="sample-container">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div id="statusBar"></div>
</div>
<div class="options-container">
<div class="option-row">
<div class="inputContainer">
<input id="selectedFile" type="file" accept=".sjs, .xlsx, .xlsm, .xltm, .xltx, .ssjson, .json, .csv" v-on:change="selectedFileChange($event)" />
<button class="settingButton" id="open" v-on:click="open">Open</button>
<div class="open-options">
<div class="item" v-show="needShow('open', 'openMode')">
<label for="open-openMode">OpenMode</label>
<select id="open-openMode" v-model.number="openOptions.openMode">
<option value="0">normal</option>
<option value="1">lazy</option>
<option value="2">incremental</option>
</select>
</div>
<div class="item" v-show="needShow('open', 'includeStyles')" >
<input type="checkbox" id="open-includeStyles" v-model="openOptions.includeStyles"/>
<label for="open-includeStyles">includeStyles</label>
</div>
<div class="item" v-show="needShow('open', 'includeFormulas')" >
<input type="checkbox" id="open-includeFormulas" v-model="openOptions.includeFormulas"/>
<label for="open-includeFormulas">includeFormulas</label>
</div>
<div class="item" v-show="needShow('open', 'frozenColumnsAsRowHeaders')" >
<input type="checkbox" id="open-frozenColumnsAsRowHeaders" v-model="openOptions.frozenColumnsAsRowHeaders"/>
<label for="open-frozenColumnsAsRowHeaders">frozenColumnsAsRowHeaders</label>
</div>
<div class="item" v-show="needShow('open', 'frozenRowsAsColumnHeaders')" >
<input type="checkbox" id="open-frozenRowsAsColumnHeaders" v-model="openOptions.frozenRowsAsColumnHeaders"/>
<label for="open-frozenRowsAsColumnHeaders">frozenRowsAsColumnHeaders</label>
</div>
<div class="item" v-show="needShow('open', 'fullRecalc')" >
<input type="checkbox" id="open-fullRecalc" v-model="openOptions.fullRecalc"/>
<label for="open-fullRecalc">fullRecalc</label>
</div>
<div class="item" v-show="needShow('open', 'dynamicReferences')" >
<input type="checkbox" id="open-dynamicReferences" v-model="openOptions.dynamicReferences"/>
<label for="open-dynamicReferences">dynamicReferences</label>
</div>
<div class="item" v-show="needShow('open', 'calcOnDemand')" >
<input type="checkbox" id="open-calcOnDemand" v-model="openOptions.calcOnDemand"/>
<label for="open-calcOnDemand">calcOnDemand</label>
</div>
<div class="item" v-show="needShow('open', 'includeUnusedStyles')" >
<input type="checkbox" id="open-includeUnusedStyles" v-model="openOptions.includeUnusedStyles"/>
<label for="open-includeUnusedStyles">includeUnusedStyles</label>
</div>
<div class="item" v-show="needShow('open', 'convertSheetTableToDataTable')" >
<input type="checkbox" id="open-convertSheetTableToDataTable" v-model="openOptions.convertSheetTableToDataTable"/>
<label for="open-convertSheetTableToDataTable">convertSheetTableToDataTable</label>
</div>
<div class="item" v-show="needShow('open', 'incrementalLoading')" >
<input type="checkbox" id="open-incrementalLoading" v-model="openOptions.incrementalLoading"/>
<label for="open-incrementalLoading">incrementalLoading</label>
</div>
<div class="item" v-show="needShow('open', 'encoding')" >
<label for="open-encoding">encoding</label>
<input type="text" id="open-encoding" v-model="openOptions.encoding"/>
</div>
<div class="item" v-show="needShow('open', 'rowDelimiter')" >
<label for="open-rowDelimiter">rowDelimiter</label>
<input type="text" id="open-rowDelimiter" v-model="openOptions.rowDelimiter"/>
</div>
<div class="item" v-show="needShow('open', 'columnDelimiter')" >
<label for="open-columnDelimiter">columnDelimiter</label>
<input type="text" id="open-columnDelimiter" v-model="openOptions.columnDelimiter"/>
</div>
</div>
</div>
<div class="inputContainer">
<label for="saveFileType">FileType:</label>
<select id="saveFileType" v-model="saveFileType">
<option value="sjs">SJS</option>
<option value="xlsx">Excel</option>
<option value="ssjson">SSJson</option>
<option value="csv">Csv</option>
</select>
<button class="settingButton" id="save" v-on:click="save">Save</button>
<div class="excelFileTypeContainer" v-show="showExcelFileType()">
<label for="fileType">Excel FileType:</label>
<div>
<select id="saveExcelFileType" v-model="excelFileType">
<option value="XLSX">Workbook (*.xlsx)</option>
<option value="XLSM">Macro-Enabled Workbook (*.xlsm)</option>
<option value="XLTM">Macro-Enabled Template (*.xltm)</option>
<option value="XLTX">Workbook Template (*.xltx)</option>
</select>
</div>
</div>
<div class="save-options">
<div class="item" v-show="needShow('save', 'includeBindingSource')" >
<input type="checkbox" id="save-includeBindingSource" v-model="saveOptions.includeBindingSource"/>
<label for="save-includeBindingSource">includeBindingSource</label>
</div>
<div class="item" v-show="needShow('save', 'includeStyles')" >
<input type="checkbox" id="save-includeStyles" v-model="saveOptions.includeStyles"/>
<label for="save-includeStyles">includeStyles</label>
</div>
<div class="item" v-show="needShow('save', 'includeFormulas')" >
<input type="checkbox" id="save-includeFormulas" v-model="saveOptions.includeFormulas"/>
<label for="save-includeFormulas">includeFormulas</label>
</div>
<div class="item" v-show="needShow('save', 'saveAsView')" >
<input type="checkbox" id="save-saveAsView" v-model="saveOptions.saveAsView"/>
<label for="save-saveAsView">saveAsView</label>
</div>
<div class="item" v-show="needShow('save', 'rowHeadersAsFrozenColumns')" >
<input type="checkbox" id="save-rowHeadersAsFrozenColumns" v-model="saveOptions.rowHeadersAsFrozenColumns"/>
<label for="save-rowHeadersAsFrozenColumns">rowHeadersAsFrozenColumns</label>
</div>
<div class="item" v-show="needShow('save', 'columnHeadersAsFrozenRows')" >
<input type="checkbox" id="save-columnHeadersAsFrozenRows" v-model="saveOptions.columnHeadersAsFrozenRows"/>
<label for="save-columnHeadersAsFrozenRows">columnHeadersAsFrozenRows</label>
</div>
<div class="item" v-show="needShow('save', 'includeAutoMergedCells')" >
<input type="checkbox" id="save-includeAutoMergedCells" v-model="saveOptions.includeAutoMergedCells"/>
<label for="save-includeAutoMergedCells">includeAutoMergedCells</label>
</div>
<div class="item" v-show="needShow('save', 'includeCalcModelCache')" >
<input type="checkbox" id="save-includeCalcModelCache" v-model="saveOptions.includeCalcModelCache"/>
<label for="save-includeCalcModelCache">includeCalcModelCache</label>
</div>
<div class="item" v-show="needShow('save', 'saveR1C1Formula')" >
<input type="checkbox" id="save-saveR1C1Formula" v-model="saveOptions.saveR1C1Formula"/>
<label for="save-saveR1C1Formula">saveR1C1Formula</label>
</div>
<div class="item" v-show="needShow('save', 'includeUnusedNames')" >
<input type="checkbox" id="save-includeUnusedNames" v-model="saveOptions.includeUnusedNames"/>
<label for="save-includeUnusedNames">includeUnusedNames</label>
</div>
<div class="item" v-show="needShow('save', 'includeEmptyRegionCells')" >
<input type="checkbox" id="save-includeEmptyRegionCells" v-model="saveOptions.includeEmptyRegionCells"/>
<label for="save-includeEmptyRegionCells">includeEmptyRegionCells</label>
</div>
<div class="item" v-show="needShow('save', 'losslessEditing')" >
<input type="checkbox" id="save-losslessEditing" v-model="saveOptions.losslessEditing"/>
<label for="save-losslessEditing">losslessEditing</label>
</div>
<div class="item" v-show="needShow('save', 'encoding')" >
<label for="save-encoding">encoding</label>
<input type="text" id="save-encoding" v-model="saveOptions.encoding"/>
</div>
<div class="item" v-show="needShow('save', 'rowDelimiter')" >
<label for="save-rowDelimiter">rowDelimiter</label>
<input type="text" id="save-rowDelimiter" v-model="saveOptions.rowDelimiter"/>
</div>
<div class="item" v-show="needShow('save', 'columnDelimiter')" >
<label for="save-columnDelimiter">columnDelimiter</label>
<input type="text" id="save-columnDelimiter" v-model="saveOptions.columnDelimiter"/>
</div>
<div class="item" v-show="needShow('save', 'sheetIndex')" >
<label for="save-sheetIndex">sheetIndex</label>
<input type="number" id="save-sheetIndex" v-model.number="saveOptions.sheetIndex"/>
</div>
<div class="item" v-show="needShow('save', 'row')" >
<label for="save-row">row</label>
<input type="number" id="save-row" v-model.number="saveOptions.row"/>
</div>
<div class="item" v-show="needShow('save', 'column')" >
<label for="save-column">column</label>
<input type="number" id="save-column" v-model.number="saveOptions.column"/>
</div>
<div class="item" v-show="needShow('save', 'rowCount')" >
<label for="save-rowCount">rowCount</label>
<input type="number" id="save-rowCount" v-model.number="saveOptions.rowCount"/>
</div>
<div class="item" v-show="needShow('save', 'columnCount')" >
<label for="save-columnCount">columnCount</label>
<input type="number" id="save-columnCount" v-model.number="saveOptions.columnCount"/>
</div>
</div>
</div>
</div>
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import { ref, toRaw } from "vue";
import '@mescius/spread-sheets-print';
import "@mescius/spread-sheets-vue";
import "@mescius/spread-sheets-io";
import '@mescius/spread-sheets-shapes';
import '@mescius/spread-sheets-charts';
import '@mescius/spread-sheets-slicers';
import '@mescius/spread-sheets-pivot-addon';
import '@mescius/spread-sheets-reportsheet-addon';
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
const openOptions = {
openMode: 0,
includeStyles: true,
includeFormulas: true,
frozenColumnsAsRowHeaders: false,
frozenRowsAsColumnHeaders: false,
fullRecalc: false,
dynamicReferences: true,
calcOnDemand: false,
includeUnusedStyles: true,
convertSheetTableToDataTable: false,
incrementalLoading: false,
encoding: "UTF-8",
rowDelimiter: "\r\n",
columnDelimiter: ","
};
const saveOptions = {
includeBindingSource: false,
includeStyles: true,
includeFormulas: true,
saveAsView: false,
rowHeadersAsFrozenColumns: false,
columnHeadersAsFrozenRows: false,
includeAutoMergedCells: false,
includeCalcModelCache: false,
saveR1C1Formula: false,
includeUnusedNames: true,
includeEmptyRegionCells: true,
losslessEditing: true,
encoding: "UTF-8",
rowDelimiter: "\r\n",
columnDelimiter: ",",
sheetIndex: 0,
row: 0,
column: 0,
rowCount: 200,
columnCount: 20,
};
const openOptionsConfig = {
sjs: [{
propName: "openMode",
type: "select",
displayText: "OpenMode",
options: [{
name: 'normal',
value: 0
}, {
name: 'lazy',
value: 1
}, {
name: 'incremental',
value: 2
}],
default: 0
}, {
propName: "includeStyles",
type: "boolean",
default: true
}, {
propName: "includeFormulas",
type: "boolean",
default: true
}, {
propName: "fullRecalc",
type: "boolean",
default: false
}, {
propName: "dynamicReferences",
type: "boolean",
default: true
}, {
propName: "calcOnDemand",
type: "boolean",
default: false
}, {
propName: "includeUnusedStyles",
type: "boolean",
default: true
}, ],
xlsx: [{
propName: "openMode",
type: "select",
displayText: "OpenMode",
options: [{
name: 'normal',
value: 0
}, {
name: 'lazy',
value: 1
}, {
name: 'incremental',
value: 2
}],
default: 0
}, {
propName: "includeStyles",
type: "boolean",
default: true
}, {
propName: "includeFormulas",
type: "boolean",
default: true
}, {
propName: "frozenColumnsAsRowHeaders",
type: "boolean",
default: false
}, {
propName: "frozenRowsAsColumnHeaders",
type: "boolean",
default: false
}, {
propName: "fullRecalc",
type: "boolean",
default: false
}, {
propName: "dynamicReferences",
type: "boolean",
default: true
}, {
propName: "calcOnDemand",
type: "boolean",
default: false
}, {
propName: "includeUnusedStyles",
type: "boolean",
default: true
}, {
propName: "convertSheetTableToDataTable",
type: "boolean",
default: false
}],
ssjson: [{
propName: "includeStyles",
type: "boolean",
default: true
}, {
propName: "includeFormulas",
type: "boolean",
default: true
}, {
propName: "frozenColumnsAsRowHeaders",
type: "boolean",
default: false
}, {
propName: "frozenRowsAsColumnHeaders",
type: "boolean",
default: false
}, {
propName: "fullRecalc",
type: "boolean",
default: false
}, {
propName: "incrementalLoading",
type: "boolean",
default: false
}],
csv: [{
propName: "encoding",
type: "string",
default: "UTF-8"
}, {
propName: "rowDelimiter",
type: "string",
default: "\r\n"
}, {
propName: "columnDelimiter",
type: "string",
default: ","
}]
};
const saveOptionsConfig = {
sjs: [{
propName: "includeBindingSource",
type: "boolean",
default: false
},
{
propName: "includeStyles",
type: "boolean",
default: true
},
{
propName: "includeFormulas",
type: "boolean",
default: true
},
{
propName: "saveAsView",
type: "boolean",
default: false
},
{
propName: "includeAutoMergedCells",
type: "boolean",
default: false
},
{
propName: "includeCalcModelCache",
type: "boolean",
default: false
},
{
propName: "saveR1C1Formula",
type: "boolean",
default: false
},
{
propName: "includeUnusedNames",
type: "boolean",
default: true
},
{
propName: "includeEmptyRegionCells",
type: "boolean",
default: true
},
],
xlsx: [{
propName: "includeBindingSource",
type: "boolean",
default: false
},
{
propName: "includeStyles",
type: "boolean",
default: true
},
{
propName: "includeFormulas",
type: "boolean",
default: true
},
{
propName: "saveAsView",
type: "boolean",
default: false
},
{
propName: "rowHeadersAsFrozenColumns",
type: "boolean",
default: false
},
{
propName: "columnHeadersAsFrozenRows",
type: "boolean",
default: false
},
{
propName: "includeAutoMergedCells",
type: "boolean",
default: false
},
{
propName: "includeUnusedNames",
type: "boolean",
default: true
},
{
propName: "includeEmptyRegionCells",
type: "boolean",
default: true
},
{
propName: "losslessEditing",
type: "boolean",
default: true
},
],
ssjson: [{
propName: "includeBindingSource",
type: "boolean",
default: false
},
{
propName: "includeStyles",
type: "boolean",
default: true
},
{
propName: "includeFormulas",
type: "boolean",
default: true
},
{
propName: "saveAsView",
type: "boolean",
default: false
},
{
propName: "rowHeadersAsFrozenColumns",
type: "boolean",
default: false
},
{
propName: "columnHeadersAsFrozenRows",
type: "boolean",
default: false
},
{
propName: "includeAutoMergedCells",
type: "boolean",
default: false
},
],
csv: [{
propName: "encoding",
type: "string",
default: "UTF-8"
},
{
propName: "rowDelimiter",
type: "string",
default: "\r\n"
},
{
propName: "columnDelimiter",
type: "string",
default: ","
},
{
propName: "sheetIndex",
type: "number",
default: 0
},
{
propName: "row",
type: "number",
default: 0
},
{
propName: "column",
type: "number",
default: 0
},
{
propName: "rowCount",
type: "number",
default: 200
},
{
propName: "columnCount",
type: "number",
default: 20
},
]
};
const spreadRef = ref(null);
const selectedFile = ref(null);
const openFileType = ref('');
const saveFileType = ref('sjs');
const excelFileType = ref('XLSX');
const initSpread = function (spread) {
spreadRef.value = spread;
let statusBar = new GC.Spread.Sheets.StatusBar.StatusBar(document.getElementById('statusBar'));
statusBar.bind(toRaw(spread));
}
const selectedFileChange = function (e) {
selectedFile.value = e.target.files[0];
openFileType.value = getFileType(selectedFile.value);
}
const open = function () {
let spread = toRaw(spreadRef.value);
let file = selectedFile.value;
if (!file) {
return;
}
let fileType = getFileType(file);
let options = getOptions('open');
if (fileType === 'sjs') {
spread.open(file, function () {}, function () {}, options);
} else {
spread.import(file, function () {}, function () {}, options);
}
}
const save = function () {
let spread = toRaw(spreadRef.value);
let fileType = saveFileType.value;
let fileName = 'export.' + (fileType==='xlsx' ? excelFileType.value.toLowerCase() : fileType);
let options = getOptions('save');
if (fileType === 'sjs') {
spread.save(function (blob) {
saveAs(blob, fileName);
}, function () {}, options);
} else {
if (fileType === 'csv') {
var { sheetIndex, row, rowCount, column, columnCount } = options;
options.range = {
sheetIndex: sheetIndex,
row: row,
rowCount: rowCount,
column: column,
columnCount: columnCount,
};
}
options.fileType = mapExportFileType(fileType);
spread.export(function (blob) {
saveAs(blob, fileName);
}, function () {}, options);
}
}
const getOptions = function (mode) {
let optionsConfig, optionsValue;
if (mode === 'open') {
optionsConfig = openOptionsConfig[openFileType.value];
optionsValue = openOptions;
} else {
optionsConfig = saveOptionsConfig[saveFileType.value];
optionsValue = saveOptions;
}
let options = {};
optionsConfig.forEach((prop) => {
let v = optionsValue[prop.propName];
if (prop.type === 'number') {
v = +v;
}
options[prop.propName] = v;
});
if (mode === 'save' && saveFileType.value === 'xlsx') {
options['excelFileType'] = excelFileType.value;
}
return options;
}
const getFileType = function (file) {
if (!file) {
return;
}
let fileName = file.name;
let extensionName = fileName.substring(fileName.lastIndexOf(".") + 1);
if (extensionName === 'sjs') {
return 'sjs';
} else if (extensionName === 'xlsx' || extensionName === 'xlsm' || extensionName === 'xltm' || extensionName === 'xltx') {
return 'xlsx';
} else if (extensionName === 'ssjson' || extensionName === 'json') {
return 'ssjson';
} else if (extensionName === 'csv') {
return 'csv';
}
}
const mapExportFileType = function (fileType) {
if (fileType === 'ssjson') {
return GC.Spread.Sheets.FileType.ssjson;
} else if (fileType === 'csv') {
return GC.Spread.Sheets.FileType.csv;
}
return GC.Spread.Sheets.FileType.excel;
}
const needShow = function (mode, propName) {
let options = mode === 'open' ? openOptionsConfig[openFileType.value] : saveOptionsConfig[saveFileType.value];
return options && options.find((p) => p.propName === propName);
}
const showExcelFileType = () => saveFileType.value === 'xlsx';
</script>
<style scoped>
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-container {
width: calc(100% - 280px);
height: 100%;
float: left;
}
.sample-spreadsheets {
width: 100%;
height: calc(100% - 25px);
overflow: hidden;
}
#statusBar {
bottom: 0;
height: 25px;
width: 100%;
position: relative;
}
.options-container {
float: right;
width: 280px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.sample-options {
z-index: 1000;
}
.inputContainer {
width: 100%;
height: auto;
border: 1px solid #eee;
padding: 6px;
margin-bottom: 10px;
box-sizing: border-box;
}
.settingButton {
color: #fff;
background: #82bc00;
outline: 0;
line-height: 1.5715;
position: relative;
display: inline-block;
font-weight: 400;
white-space: nowrap;
text-align: center;
height: 32px;
padding: 4px 15px;
font-size: 14px;
border-radius: 2px;
user-select: none;
cursor: pointer;
border: 1px solid #82bc00;
box-sizing: border-box;
margin-bottom: 10px;
margin-top: 10px;
}
.settingButton:hover {
color: #fff;
border-color: #88b031;
background: #88b031;
}
.options-title {
font-weight: bold;
margin: 4px 2px;
}
#selectedFile {
width: 180px;
}
#saveFileType {
width: 120px;
height: 31px;
}
.open-options .item {
margin: 5px 0px;
display: flex;
}
.save-options .item {
margin: 5px 0px;
display: flex;
}
label {
margin-left: 3px;
}
select, input[type="text"], input[type="number"] {
display: inline-block;
margin-left: auto;
width: 120px;
font-weight: 400;
outline: 0;
line-height: 1.5715;
border-radius: 2px;
border: 1px solid #F4F8EB;
box-sizing: border-box;
}
.excelFileTypeContainer {
margin-bottom: 10px;
}
#saveExcelFileType {
margin: 10px 0;
width: 100%;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/js/FileSaver.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.3-master-2026-06-24-2132/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-print': 'cdn:@mescius/spread-sheets-print/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-io': 'cdn:@mescius/spread-sheets-io/index.js',
'@mescius/spread-sheets-charts': 'cdn:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'cdn:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-pivot-addon': 'cdn:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-reportsheet-addon': 'cdn:@mescius/spread-sheets-reportsheet-addon/index.js',
'@mescius/spread-sheets-tablesheet': 'cdn:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-ganttsheet': 'cdn:@mescius/spread-sheets-ganttsheet/index.js',
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

In order to use the SpreadJS File Format feature, you need to add the related js file link into the document's head section below the Spread link. For example:
SpreadJS supports opening and saving sjs file formats. It also supports importing and exporting xlsx, xlsm, xltm, ssjson, and csv file formats.
For example:
class GC.Spread.Sheets.Workbook
GC.Spread.Sheets.SaveOptions
GC.Spread.Sheets.OpenOptions
GC.Spread.Sheets.ImportOptions
GC.Spread.Sheets.ExportOptions
GC.Spread.Sheets.ExcelFileType
GC.Spread.Sheets.ImportXlsxOptions
GC.Spread.Sheets.ExportXlsxOptions
GC.Spread.Sheets.ImportCsvOptions
.Spread.Sheets.ExportCsvOptions
GC.Spread.Sheets.ImportSSJsonOptions
GC.Spread.Sheets.ExportSSJsonOptions
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-print';
import '@mescius/spread-sheets-io';
import '@mescius/spread-sheets-shapes';
import '@mescius/spread-sheets-charts';
import '@mescius/spread-sheets-slicers';
import '@mescius/spread-sheets-pivot-addon';
import '@mescius/spread-sheets-reportsheet-addon';
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
window.GC = GC;
function deepClone(obj) {
return JSON.parse(JSON.stringify(obj));
}
function getElementId(mode, fileType, propName) {
return mode + '-' + fileType + '-' + propName;
}
function getFileType(file) {
if (!file) {
return;
}
var fileName = file.name;
var extensionName = fileName.substring(fileName.lastIndexOf(".") + 1);
if (extensionName === 'sjs') {
return FileType.SJS;
} else if (extensionName === 'xlsx' || extensionName === 'xlsm' || extensionName === 'xltm') {
return FileType.Excel;
} else if (extensionName === 'ssjson' || extensionName === 'json') {
return FileType.SSJson;
} else if (extensionName === 'csv') {
return FileType.Csv;
}
}
function mapExportFileType(fileType) {
if (fileType === FileType.SSJson) {
return GC.Spread.Sheets.FileType.ssjson;
} else if (fileType === FileType.Csv) {
return GC.Spread.Sheets.FileType.csv;
}
return GC.Spread.Sheets.FileType.excel;
}
function _getElementById(id) {
return document.getElementById(id);
}
var defaultOpenOptions = [
{ propName: "openMode", type: "select", displayText: "OpenMode", options: [{ name: 'normal', value: 0 }, { name: 'lazy', value: 1 }, { name: 'incremental', value: 2 }], default: 0 },
{ propName: "includeStyles", type: "boolean", default: true },
{ propName: "includeFormulas", type: "boolean", default: true },
{ propName: "fullRecalc", type: "boolean", default: false },
{ propName: "dynamicReferences", type: "boolean", default: true },
{ propName: "calcOnDemand", type: "boolean", default: false },
{ propName: "includeUnusedStyles", type: "boolean", default: true },
];
var importXlsxOptions = [
{ propName: "openMode", type: "select", displayText: "OpenMode", options: [{ name: 'normal', value: 0 }, { name: 'lazy', value: 1 }, { name: 'incremental', value: 2 }], default: 0 },
{ propName: "includeStyles", type: "boolean", default: true },
{ propName: "includeFormulas", type: "boolean", default: true },
{ propName: "frozenColumnsAsRowHeaders", type: "boolean", default: false },
{ propName: "frozenRowsAsColumnHeaders", type: "boolean", default: false },
{ propName: "fullRecalc", type: "boolean", default: false },
{ propName: "dynamicReferences", type: "boolean", default: true },
{ propName: "calcOnDemand", type: "boolean", default: false },
{ propName: "includeUnusedStyles", type: "boolean", default: true },
{ propName: "convertSheetTableToDataTable", type: "boolean", default: false },
];
var importSSJsonOptions = [
{ propName: "includeStyles", type: "boolean", default: true },
{ propName: "includeFormulas", type: "boolean", default: true },
{ propName: "frozenColumnsAsRowHeaders", type: "boolean", default: false },
{ propName: "frozenRowsAsColumnHeaders", type: "boolean", default: false },
{ propName: "fullRecalc", type: "boolean", default: false },
{ propName: "incrementalLoading", type: "boolean", default: false }
];
var importCsvOptions = [
{ propName: "encoding", type: "string", default: "UTF-8" },
{ propName: "rowDelimiter", type: "string", default: "\r\n" },
{ propName: "columnDelimiter", type: "string", default: "," }
];
var defaultSaveOptions = [
{ propName: "includeBindingSource", type: "boolean", default: false },
{ propName: "includeStyles", type: "boolean", default: true },
{ propName: "includeFormulas", type: "boolean", default: true },
{ propName: "saveAsView", type: "boolean", default: false },
{ propName: "includeAutoMergedCells", type: "boolean", default: false },
{ propName: "includeCalcModelCache", type: "boolean", default: false },
{ propName: "saveR1C1Formula", type: "boolean", default: false },
{ propName: "includeUnusedNames", type: "boolean", default: true },
{ propName: "includeEmptyRegionCells", type: "boolean", default: true },
];
var exportXlsxOptions = [
{ propName: "includeBindingSource", type: "boolean", default: false },
{ propName: "includeStyles", type: "boolean", default: true },
{ propName: "includeFormulas", type: "boolean", default: true },
{ propName: "saveAsView", type: "boolean", default: false },
{ propName: "rowHeadersAsFrozenColumns", type: "boolean", default: false },
{ propName: "columnHeadersAsFrozenRows", type: "boolean", default: false },
{ propName: "includeAutoMergedCells", type: "boolean", default: false },
{ propName: "includeUnusedNames", type: "boolean", default: true },
{ propName: "includeEmptyRegionCells", type: "boolean", default: true },
{ propName: "losslessEditing", type: "boolean", default: true },
];
var exportSSJsonOptions = [
{ propName: "includeBindingSource", type: "boolean", default: false },
{ propName: "includeStyles", type: "boolean", default: true },
{ propName: "includeFormulas", type: "boolean", default: true },
{ propName: "saveAsView", type: "boolean", default: false },
{ propName: "rowHeadersAsFrozenColumns", type: "boolean", default: false },
{ propName: "columnHeadersAsFrozenRows", type: "boolean", default: false },
{ propName: "includeAutoMergedCells", type: "boolean", default: false },
];
var exportCsvOptions = [
{ propName: "encoding", type: "string", default: "UTF-8" },
{ propName: "rowDelimiter", type: "string", default: "\r\n" },
{ propName: "columnDelimiter", type: "string", default: "," },
{ propName: "sheetIndex", type: "number", default: 0 },
{ propName: "row", type: "number", default: 0 },
{ propName: "column", type: "number", default: 0 },
{ propName: "rowCount", type: "number", default: 200 },
{ propName: "columnCount", type: "number", default: 20 },
];
var FileType = {
SJS: 'sjs',
Excel: 'xlsx',
SSJson: 'ssjson',
Csv: 'csv',
}
const ExcelFileType = {
xlsx : 'XLSX',
xlsm : 'XLSM',
xltm : 'XLTM',
}
export function AppFunc() {
const [spread, setSpread] = React.useState(null);
const [selectedFile, setSelectedFile] = React.useState(null);
const [openFileType, setOpenFileType] = React.useState('');
const [saveFileType, setSaveFileType] = React.useState(FileType.SJS);
const [excelFileType, setExcelFileType] = React.useState(ExcelFileType.xlsx);
const [openOptions, setOpenOptions] = React.useState({
sjs: {},
ssjson: {},
xlsx: {},
csv: {},
});
const [saveOptions, setSaveOptions] = React.useState({
sjs: {},
ssjson: {},
xlsx: {},
csv: {},
});
function initSpread(spread) {
setSpread(spread);
//init Status Bar
var statusBar = new GC.Spread.Sheets.StatusBar.StatusBar(document.getElementById('statusBar'));
statusBar.bind(spread);
}
function open() {
var file = selectedFile;
if (!file) {
return;
}
var fileType = getFileType(file);
var options = deepClone(openOptions[fileType]);
if (fileType === FileType.SJS) {
spread.open(file, function () { }, function () { }, options);
} else {
spread.import(file, function () { }, function () { }, options);
}
}
function save() {
var fileType = saveFileType;
var fileName = 'export.' + (fileType === FileType.Excel ? excelFileType.toLowerCase() : fileType);
var options = deepClone(saveOptions[fileType]);
if (fileType === FileType.SJS) {
spread.save(function (blob) { saveAs(blob, fileName); }, function () { }, options);
} else {
if (fileType === FileType.Csv) {
var { sheetIndex, row, rowCount, column, columnCount } = options;
options.range = {
sheetIndex: sheetIndex,
row: row,
rowCount: rowCount,
column: column,
columnCount: columnCount,
};
}
options.fileType = mapExportFileType(fileType);
spread.export(function (blob) { saveAs(blob, fileName); }, function () { }, options);
}
}
function onSelectedFileChange(e) {
let selectedFile = e.target.files[0];
let openFileType = getFileType(selectedFile);
setSelectedFile(selectedFile);
setOpenFileType(openFileType)
}
function onSaveFileTypeChange(e) {
let saveFileType = e.target.value;
setSaveFileType(saveFileType);
}
const onExcelFileTypeChange = (e) => {
const newExcelFileType = e.target.value;
setExcelFileType(newExcelFileType);
saveOptions.xlsx['excelFileType'] = newExcelFileType;
setSaveOptions(saveOptions);
}
function onPropChange(mode, fileType, prop, e) {
let element = e.target;
var value;
if (prop.type === 'boolean') {
value = element.checked;
} else if (prop.type === 'number') {
value = +element.value;
} else if (prop.type === 'string') {
value = element.value;
} else if (prop.type === 'select') {
value = +element.value;
}
if (mode === 'open') {
openOptions[fileType][prop.propName] = value;
setOpenOptions(openOptions);
} else if (mode === 'save') {
saveOptions[fileType][prop.propName] = value;
setSaveOptions(saveOptions);
}
}
function createOptions(options, fileType, mode) {
let selectFileType = mode === 'open' ? openFileType : saveFileType;
let display = selectFileType === fileType ? '' : 'none';
return <div className={fileType} style={{ display }}>
{options.map((prop) => createProp(mode, fileType, prop))}
</div>;
}
function createProp(mode, fileType, prop) {
let id = getElementId(mode, fileType, prop.propName);
if (prop.type === 'select') {
return <item className='item'>
<label for={id}>{prop.displayText || prop.propName}</label>
<select id={id} defaultValue={prop.default} onChange={(e) => onPropChange(mode, fileType, prop, e)}>
{prop.options.map((p) => <option value={p.value}>{p.name}</option>)}
</select>
</item>
} else if (prop.type === 'boolean') {
return <item className='item'>
<input id={id} type='checkbox' defaultChecked={prop.default} onChange={(e) => onPropChange(mode, fileType, prop, e)}></input>
<label for={id}>{prop.displayText || prop.propName}</label>
</item>
} else if (prop.type === 'number') {
return <item className='item'>
<label for={id}>{prop.displayText || prop.propName}</label>
<input id={id} type='number' defaultValue={prop.default} onChange={(e) => onPropChange(mode, fileType, prop, e)}></input>
</item>
} else {
return <item className='item'>
<label for={id}>{prop.displayText || prop.propName}</label>
<input id={id} type='text' defaultValue={prop.default} onChange={(e) => onPropChange(mode, fileType, prop, e)}></input>
</item>
}
}
return <div class="sample-tutorial">
<div class="sample-container">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<div id="statusBar"></div>
</div>
<div className="options-container">
<div className="option-row">
<div class="inputContainer">
<input id="selectedFile" type="file" accept=".sjs, .xlsx, .xlsm, .xltm, .ssjson, .json, .csv" onChange={onSelectedFileChange} />
<button class="settingButton" id="open" onClick={open}>Open</button>
<div class="open-options">
{[
createOptions(defaultOpenOptions, FileType.SJS, 'open'),
createOptions(importXlsxOptions, FileType.Excel, 'open'),
createOptions(importSSJsonOptions, FileType.SSJson, 'open'),
createOptions(importCsvOptions, FileType.Csv, 'open'),
]}
</div>
</div>
<div class="inputContainer">
<label for="saveFileType">FileType:</label>
<select id="saveFileType" value={saveFileType} onChange={onSaveFileTypeChange}>
<option value="sjs">SJS</option>
<option value="xlsx">Excel</option>
<option value="ssjson">SSJson</option>
<option value="csv">Csv</option>
</select>
<button class="settingButton" id="save" onClick={save}>Save</button>
{saveFileType === FileType.Excel && <div class="excelFileTypeContainer">
<label for="fileType">Excel FileType:</label>
<div>
<select id="saveExcelFileType" value={excelFileType} onChange={onExcelFileTypeChange}>
<option value="XLSX">Workbook (*.xlsx)</option>
<option value="XLSM">Macro-Enabled Workbook (*.xlsm)</option>
<option value="XLTM">Macro-Enabled Template (*.xltm)</option>
</select>
</div>
</div>}
<div class="save-options">
{[
createOptions(defaultSaveOptions, FileType.SJS, 'save'),
createOptions(exportXlsxOptions, FileType.Excel, 'save'),
createOptions(exportSSJsonOptions, FileType.SSJson, 'save'),
createOptions(exportCsvOptions, FileType.Csv, 'save'),
]}
</div>
</div>
</div>
</div>
</div>;
}
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-print';
import '@mescius/spread-sheets-io';
import '@mescius/spread-sheets-shapes';
import '@mescius/spread-sheets-charts';
import '@mescius/spread-sheets-slicers';
import '@mescius/spread-sheets-pivot-addon';
import '@mescius/spread-sheets-reportsheet-addon';
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
import './styles.css';
const Component = React.Component;
window.GC = GC;
var openOptions = [
{ propName: "openMode", type: "select", displayText: "OpenMode", options: [{name: 'normal', value: 0}, {name: 'lazy', value: 1}, {name: 'incremental', value: 2}], default: 0 },
{ propName: "includeStyles", type: "boolean", default: true },
{ propName: "includeFormulas", type: "boolean", default: true },
{ propName: "fullRecalc", type: "boolean", default: false },
{ propName: "dynamicReferences", type: "boolean", default: true },
{ propName: "calcOnDemand", type: "boolean", default: false },
{ propName: "includeUnusedStyles", type: "boolean", default: true },
];
var importXlsxOptions = [
{ propName: "openMode", type: "select", displayText: "OpenMode", options: [{name: 'normal', value: 0}, {name: 'lazy', value: 1}, {name: 'incremental', value: 2}], default: 0 },
{ propName: "includeStyles", type: "boolean", default: true },
{ propName: "includeFormulas", type: "boolean", default: true },
{ propName: "frozenColumnsAsRowHeaders", type: "boolean", default: false },
{ propName: "frozenRowsAsColumnHeaders", type: "boolean", default: false },
{ propName: "fullRecalc", type: "boolean", default: false },
{ propName: "dynamicReferences", type: "boolean", default: true },
{ propName: "calcOnDemand", type: "boolean", default: false },
{ propName: "includeUnusedStyles", type: "boolean", default: true },
{ propName: "convertSheetTableToDataTable", type: "boolean", default: false },
];
var importSSJsonOptions = [
{ propName: "includeStyles", type: "boolean", default: true },
{ propName: "includeFormulas", type: "boolean", default: true },
{ propName: "frozenColumnsAsRowHeaders", type: "boolean", default: false },
{ propName: "frozenRowsAsColumnHeaders", type: "boolean", default: false },
{ propName: "fullRecalc", type: "boolean", default: false },
{ propName: "incrementalLoading", type: "boolean", default: false }
];
var importCsvOptions = [
{ propName: "encoding", type: "string", default: "UTF-8" },
{ propName: "rowDelimiter", type: "string", default: "\r\n" },
{ propName: "columnDelimiter", type: "string", default: "," }
];
var saveOptions = [
{ propName: "includeBindingSource", type: "boolean", default: false },
{ propName: "includeStyles", type: "boolean", default: true },
{ propName: "includeFormulas", type: "boolean", default: true },
{ propName: "saveAsView", type: "boolean", default: false },
{ propName: "includeAutoMergedCells", type: "boolean", default: false },
{ propName: "includeCalcModelCache", type: "boolean", default: false },
{ propName: "saveR1C1Formula", type: "boolean", default: false },
{ propName: "includeUnusedNames", type: "boolean", default: true },
{ propName: "includeEmptyRegionCells", type: "boolean", default: true },
];
var exportXlsxOptions = [
{ propName: "includeBindingSource", type: "boolean", default: false },
{ propName: "includeStyles", type: "boolean", default: true },
{ propName: "includeFormulas", type: "boolean", default: true },
{ propName: "saveAsView", type: "boolean", default: false },
{ propName: "rowHeadersAsFrozenColumns", type: "boolean", default: false },
{ propName: "columnHeadersAsFrozenRows", type: "boolean", default: false },
{ propName: "includeAutoMergedCells", type: "boolean", default: false },
{ propName: "includeUnusedNames", type: "boolean", default: true },
{ propName: "includeEmptyRegionCells", type: "boolean", default: true },
{ propName: "losslessEditing", type: "boolean", default: true },
];
var exportSSJsonOptions = [
{ propName: "includeBindingSource", type: "boolean", default: false },
{ propName: "includeStyles", type: "boolean", default: true },
{ propName: "includeFormulas", type: "boolean", default: true },
{ propName: "saveAsView", type: "boolean", default: false },
{ propName: "rowHeadersAsFrozenColumns", type: "boolean", default: false },
{ propName: "columnHeadersAsFrozenRows", type: "boolean", default: false },
{ propName: "includeAutoMergedCells", type: "boolean", default: false },
];
var exportCsvOptions = [
{ propName: "encoding", type: "string", default: "UTF-8" },
{ propName: "rowDelimiter", type: "string", default: "\r\n" },
{ propName: "columnDelimiter", type: "string", default: "," },
{ propName: "sheetIndex", type: "number", default: 0 },
{ propName: "row", type: "number", default: 0 },
{ propName: "column", type: "number", default: 0 },
{ propName: "rowCount", type: "number", default: 200 },
{ propName: "columnCount", type: "number", default: 20 },
];
var FileType = {
SJS: 'sjs',
Excel: 'xlsx',
SSJson: 'ssjson',
Csv: 'csv',
}
const ExcelFileType = {
xlsx : 'XLSX',
xlsm : 'XLSM',
xltm : 'XLTM',
}
function deepClone (obj) {
return JSON.parse(JSON.stringify(obj));
}
function getElementId (mode, fileType, propName) {
return mode + '-' + fileType + '-' + propName;
}
function getFileType (file) {
if (!file) {
return;
}
var fileName = file.name;
var extensionName = fileName.substring(fileName.lastIndexOf(".") + 1);
if (extensionName === 'sjs') {
return FileType.SJS;
} else if (extensionName === 'xlsx' || extensionName === 'xlsm' || extensionName === 'xltm') {
return FileType.Excel;
} else if (extensionName === 'ssjson' || extensionName === 'json') {
return FileType.SSJson;
} else if (extensionName === 'csv') {
return FileType.Csv;
}
}
function mapExportFileType (fileType) {
if (fileType === FileType.SSJson) {
return GC.Spread.Sheets.FileType.ssjson;
} else if (fileType === FileType.Csv) {
return GC.Spread.Sheets.FileType.csv;
}
return GC.Spread.Sheets.FileType.excel;
}
function _getElementById(id) {
return document.getElementById(id);
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
selectedFile: null,
openFileType: '',
saveFileType: FileType.SJS,
excelFileType: ExcelFileType.xlsx,
openOptions: {
sjs: {},
ssjson: {},
xlsx: {},
csv: {},
},
saveOptions: {
sjs: {},
ssjson: {},
xlsx: {},
csv: {},
}
};
this.open = this.open.bind(this);
this.save = this.save.bind(this);
this.onSelectedFileChange = this.onSelectedFileChange.bind(this);
this.onSaveFileTypeChange = this.onSaveFileTypeChange.bind(this);
this.onExcelFileTypeChange = this.onExcelFileTypeChange.bind(this);
this.onPropChange = this.onPropChange.bind(this);
}
render() {
return <div class="sample-tutorial">
<div class="sample-container">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<div id="statusBar"></div>
</div>
<div className="options-container">
<div className="option-row">
<div class="inputContainer">
<input id="selectedFile" type="file" accept=".sjs, .xlsx, .xlsm, .xltm, .ssjson, .json, .csv" onChange={this.onSelectedFileChange} />
<button class="settingButton" id="open" onClick={this.open}>Open</button>
<div class="open-options">
{[
this.createOptions(openOptions, FileType.SJS, 'open'),
this.createOptions(importXlsxOptions, FileType.Excel, 'open'),
this.createOptions(importSSJsonOptions, FileType.SSJson, 'open'),
this.createOptions(importCsvOptions, FileType.Csv, 'open'),
]}
</div>
</div>
<div class="inputContainer">
<label for="saveFileType">FileType:</label>
<select id="saveFileType" value={this.state.saveFileType} onChange={this.onSaveFileTypeChange}>
<option value="sjs">SJS</option>
<option value="xlsx">Excel</option>
<option value="ssjson">SSJson</option>
<option value="csv">Csv</option>
</select>
<button class="settingButton" id="save" onClick={this.save}>Save</button>
{
this.state.saveFileType === FileType.Excel && <div class="excelFileTypeContainer">
<label for="fileType">Excel FileType:</label>
<div>
<select id="saveExcelFileType" value={this.state.excelFileType} onChange={this.onExcelFileTypeChange}>
<option value="XLSX">Workbook (*.xlsx)</option>
<option value="XLSM">Macro-Enabled Workbook (*.xlsm)</option>
<option value="XLTM">Macro-Enabled Template (*.xltm)</option>
</select>
</div>
</div>
}
<div class="save-options">
{[
this.createOptions(saveOptions, FileType.SJS, 'save'),
this.createOptions(exportXlsxOptions, FileType.Excel, 'save'),
this.createOptions(exportSSJsonOptions, FileType.SSJson, 'save'),
this.createOptions(exportCsvOptions, FileType.Csv, 'save'),
]}
</div>
</div>
</div>
</div>
</div>;
}
initSpread(spread) {
this.spread = spread;
//init Status Bar
var statusBar = new GC.Spread.Sheets.StatusBar.StatusBar(document.getElementById('statusBar'));
statusBar.bind(spread);
}
open() {
var file = this.state.selectedFile;
if (!file) {
return;
}
var fileType = getFileType(file);
var options = deepClone(this.state.openOptions[fileType]);
if (fileType === FileType.SJS) {
this.spread.open(file, function() {}, function() {}, options);
} else {
this.spread.import(file, function() {}, function() {}, options);
}
}
save() {
var fileType = this.state.saveFileType;
var fileName = 'export.' + (fileType === FileType.Excel ? this.state.excelFileType.toLowerCase() : fileType);
var options = deepClone(this.state.saveOptions[fileType]);
if (fileType === FileType.SJS) {
this.spread.save(function(blob) { saveAs(blob, fileName); }, function() {}, options);
} else {
if (fileType === FileType.Csv) {
var { sheetIndex, row, rowCount, column, columnCount } = options;
options.range = {
sheetIndex: sheetIndex,
row: row,
rowCount: rowCount,
column: column,
columnCount: columnCount,
};
}
options.fileType = mapExportFileType(fileType);
this.spread.export(function(blob) { saveAs(blob, fileName); }, function() {}, options);
}
}
onSelectedFileChange(e) {
let selectedFile = e.target.files[0];
let openFileType = getFileType(selectedFile);
this.setState({ ...this.state, selectedFile, openFileType });
}
onSaveFileTypeChange(e) {
let saveFileType = e.target.value;
this.setState({ ...this.state, saveFileType });
}
onExcelFileTypeChange (e) {
const excelFileType = e.target.value;
let saveOptions = deepClone(this.state.saveOptions);
saveOptions.xlsx['excelFileType'] = excelFileType;
this.setState({ ...this.state, excelFileType, saveOptions});
}
onPropChange (mode, fileType, prop, e) {
let element = e.target;
var value;
if (prop.type === 'boolean') {
value = element.checked;
} else if (prop.type === 'number') {
value = +element.value;
} else if (prop.type === 'string') {
value = element.value;
} else if (prop.type === 'select') {
value = +element.value;
}
if (mode === 'open') {
let openOptions = deepClone(this.state.openOptions);
openOptions[fileType][prop.propName] = value;
this.setState({...this.state, openOptions});
} else if (mode === 'save') {
let saveOptions = deepClone(this.state.saveOptions);
saveOptions[fileType][prop.propName] = value;
this.setState({...this.state, saveOptions});
}
}
createOptions (options, fileType, mode) {
let selectFileType = mode === 'open' ? this.state.openFileType : this.state.saveFileType;
let display = selectFileType === fileType ? '' : 'none';
return <div className={fileType} style={{display}}>
{ options.map((prop) => this.createProp(mode, fileType, prop)) }
</div>;
}
createProp (mode, fileType, prop) {
let id = getElementId(mode, fileType, prop.propName);
if (prop.type === 'select') {
return <item className='item'>
<label for={id}>{prop.displayText || prop.propName}</label>
<select id={id} defaultValue={prop.default} onChange={(e) => this.onPropChange(mode, fileType, prop, e)}>
{ prop.options.map((p) => <option value={p.value}>{p.name}</option>) }
</select>
</item>
} else if (prop.type === 'boolean') {
return <item className='item'>
<input id={id} type='checkbox' defaultChecked={prop.default} onChange={(e) => this.onPropChange(mode, fileType, prop, e)}></input>
<label for={id}>{prop.displayText || prop.propName}</label>
</item>
} else if (prop.type === 'number') {
return <item className='item'>
<label for={id}>{prop.displayText || prop.propName}</label>
<input id={id} type='number' defaultValue={prop.default} onChange={(e) => this.onPropChange(mode, fileType, prop, e)}></input>
</item>
} else {
return <item className='item'>
<label for={id}>{prop.displayText || prop.propName}</label>
<input id={id} type='text' defaultValue={prop.default} onChange={(e) => this.onPropChange(mode, fileType, prop, e)}></input>
</item>
}
}
}
createRoot(document.getElementById('app')).render(<App />);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/js/FileSaver.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-container {
width: calc(100% - 280px);
height: 100%;
float: left;
}
.sample-spreadsheets {
width: 100%;
height: calc(100% - 25px);
overflow: hidden;
}
#statusBar {
bottom: 0;
height: 25px;
width: 100%;
position: relative;
}
.options-container {
float: right;
width: 280px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.sample-options {
z-index: 1000;
}
.inputContainer {
width: 100%;
height: auto;
border: 1px solid #eee;
padding: 6px;
margin-bottom: 10px;
box-sizing: border-box;
}
.settingButton {
color: #fff;
background: #82bc00;
outline: 0;
line-height: 1.5715;
position: relative;
display: inline-block;
font-weight: 400;
white-space: nowrap;
text-align: center;
height: 32px;
padding: 4px 15px;
font-size: 14px;
border-radius: 2px;
user-select: none;
cursor: pointer;
border: 1px solid #82bc00;
box-sizing: border-box;
margin-bottom: 10px;
margin-top: 10px;
}
.settingButton:hover {
color: #fff;
border-color: #88b031;
background: #88b031;
}
.options-title {
font-weight: bold;
margin: 4px 2px;
}
#selectedFile {
width: 180px;
}
#saveFileType {
width: 120px;
height: 31px;
}
.open-options .item {
margin: 5px 0px;
display: flex;
}
.save-options .item {
margin: 5px 0px;
display: flex;
}
label {
margin-left: 3px;
}
select, input[type="text"], input[type="number"] {
display: inline-block;
margin-left: auto;
width: 120px;
font-weight: 400;
outline: 0;
line-height: 1.5715;
border-radius: 2px;
border: 1px solid #F4F8EB;
box-sizing: border-box;
}
.excelFileTypeContainer {
margin-bottom: 10px;
}
#saveExcelFileType {
margin: 10px 0;
width: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-print': 'npm:@mescius/spread-sheets-print/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'npm:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-reportsheet-addon': 'npm:@mescius/spread-sheets-reportsheet-addon/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-ganttsheet': 'npm:@mescius/spread-sheets-ganttsheet/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);